<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

//: move "defines" to member variables
define("URL_2CHECKOUT_ROUTINE", "https://www.2checkout.com/checkout/purchase");
define("URL_2CHECKOUT_ONE_STEP", "https://www.2checkout.com/checkout/spurchase");

/**
 *
 * @package PaymentModule2CheckoutCC.
 * @author Egor Makarov
 */
class Payment_Module_2Checkout_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModulePaypal constructor.
     */
    function Payment_Module_2Checkout_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_2CHECKOUT_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");

        $tables = Payment_Module_2Checkout_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_2checkout_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_ID", $columns['key']);
        $query->addInsertValue('s:7:"Your ID";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_SECRET", $columns['key']);
        $query->addInsertValue('s:16:"Your secret word";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_USE_SECRET", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_CHECKOUT", $columns['key']);
        $query->addInsertValue('s:6:"COMMON";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_2Checkout_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_2Checkout_CC                    2 PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_2CHECKOUT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "F9217D80-8485-11DB-9AF5-0002A5D5C51B";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModule2CheckoutCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModule2CheckoutCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModule2CheckoutCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_2checkout_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_2checkout_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_2checkout_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_2checkout_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_2checkout_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_2checkout_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);

        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask("Shipping", "attr", AAL_CUSTOM_PARAM, "value");

        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

        $this->getSettings();
        $confirmationData = array
            (
                 "FormAction" => ($this->Settings["MODULE_CHECKOUT"] == 'COMMON') ? URL_2CHECKOUT_ROUTINE : URL_2CHECKOUT_ONE_STEP
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    //
                    // common info
                    //
                     "sid"               => $this->Settings["MODULE_ID"]
                    ,"total"             => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', '')
                    ,"cart_order_id"     => $orderId // should be an internal oder number in the system
                    ,"fixed"             => "Y"
                    ,"merchant_order_id" => $orderId
                    ,"pay_method"        => "CC" // credit card payment
                    //
                    // shipping info
                    //
                    ,"ship_name"       => $shippingInfo->getByMask('Firstname').' '.$shippingInfo->getByMask('Lastname')
                    ,"ship_street_address" => $shippingInfo->getByMask('Streetline2').' '.$shippingInfo->getByMask('Streetline2')
                    ,"ship_city"       => $shippingInfo->getByMask('City')
                    ,"ship_country"    => $shippingInfo->getByMask('Country')
                    ,"ship_state"      => $shippingInfo->getByMask('State')
                    ,"ship_zip"        => $shippingInfo->getByMask('Postcode')
                    //
                    // billing info
                    //
                    ,"card_holder_name" => $billingInfo->getByMask('Firstname')." ".$billingInfo->getByMask('Lastname')
                    ,"phone"            => $billingInfo->getByMask('Phone')// - buyers phone number (16 characters max)
                    ,"email"            => $billingInfo->getByMask('Email')// - buyers email address (64 characters max)
                    ,"street_address"   => $billingInfo->getByMask('Streetline1')." ".$billingInfo->getByMask('Streetline2') // - buyers address (64 characters max)
                    ,"city"             => $billingInfo->getByMask('City')// - buyers city (64 characters max)
                    ,"state"            => $billingInfo->getByMask('State')// - buyers state (64 characters max)
                    ,"zip"              => $billingInfo->getByMask('Postcode')// - buyers zip code (16 characters max)
                    ,"country"          => $billingInfo->getByMask('Country')// - buyers country (64 characters max)
                    //
                    // notification URL
                    //
                    ,"x_Receipt_Link_URL" => $self_link
                )
            );

        //
        // check the transacton mode - test/production
        //
        $settings = $this->getSettings();
        if ($settings["MODULE_MODE"] == '1')
        {
        	$confirmationData["DataFields"]["demo"] = "Y";
        }
        //
        // Everything, that is referred to "new parameters"
        //
        $confirmationData["DataFields"]["id_type"] = "1"; // 1 is defined as vendor_product_id
        //$confirmationData["DataFields"]["sh_cost"] = number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost")), 2, ".", "");
        for ($i = 0; $i < sizeof($orderInfo["Products"]); $i++)
        {
            // c_prod_[i]
            $confirmationData["DataFields"]["c_prod_".$i] = $orderInfo["Products"][$i]["id"] .
            "," . $orderInfo["Products"][$i]["qty"];
            // c_name_[i]
            $confirmationData["DataFields"]["c_name_".$i] = prepareHTMLDisplay($orderInfo["Products"][$i]["name"]);
            // c_description_[i]
            $confirmationData["DataFields"]["c_description_".$i] = prepareHTMLDisplay($orderInfo["Products"][$i]["name"]);
            // c_price_[i]
            $confirmationData["DataFields"]["c_price_".$i] = $orderInfo["Products"][$i]["SalePrice"];
        }
        return $confirmationData;
    }


    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");

        //
        // add incoming order message to history
        //
        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_MESSAGE_INCOMMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_EXTRA') . "\n" .
            print_r($data["_POST"], true);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        //
        // check if necessary POST-parameters exist
        //
        $isPostValid = array_key_exists("credit_card_processed", $data["_POST"]) &&
            array_key_exists("total", $data["_POST"]) &&
            array_key_exists("key", $data["_POST"]) &&
            array_key_exists("order_number", $data["_POST"]);

        //
        // Check the MD5 key
        //
        $verified = $isPostValid;
        if ($this->Settings["MODULE_USE_SECRET"] == "1" && $isPostValid == true)
        {
            $order_number = $this->Settings["MODULE_MODE"] == "1" ? "1" : $data["_POST"]["order_number"];
            $strToHash = $this->Settings["MODULE_SECRET"] . $this->Settings["MODULE_ID"] .
                    $order_number . $data["_POST"]["total"];
            $checkKey = _ml_strtoupper(md5($strToHash));
            if (($checkKey == $data["_POST"]["key"]) == false)
            {
                $verified = false;
            }
        }

        if ($verified == true)
        {
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID",
                $order_id, $data["_POST"]["order_number"]);
            $status = $data["_POST"]["credit_card_processed"];
            // the status update
            switch ($status)
            {
                case "Y":
                    // the customer card has been checked
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_MESSAGE_COMPLETED'));
                    break;

                case "K":
                    // the customer card can't be checked now
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_2CHECKOUT_LOG_MESSAGE_PENDING'));
                    break;

                default:
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage("MODULE_PAYMENT_2CHECKOUT_LOG_MESSAGE_MD5FAILURE"));
                    break;
             }
        }
        else
        {
            // the query failed the md5 key checking or doesn't contain necessary POST-data
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                $msg->getMessage("MODULE_PAYMENT_2CHECKOUT_LOG_MESSAGE_MD5FAILURE"));
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_2Checkout_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_2checkout_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_2checkout_setting_id'
               ,'key'               => $settings.'.pm_2checkout_setting_key'
               ,'value'             => $settings.'.pm_2checkout_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>