<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleCamtechCC
 * @author Sergey Kulitsky
 *
 */

class update_camtech extends update_pm_sm
{
    function update_chase()
    {}

    function onAction()
    {
        global $application;
        parent::onAction();

        $request = new Request();

        $status = $request->getValueByKey('status');


        $name = $request->getValueByKey('MODULE_NAME');
        $cid = $request->getValueByKey('CAMTECH_MERCHANT_ID');
        $mode = $request->getValueByKey('MODULE_MODE');
        $password = $request->getValueByKey('CAMTECH_PASSWORD');

        $errors = array();

        if($status == 'active')
        {
            if(!modApiFunc('Checkout', 'arePersonInfoTypesActive',
                           array("billingInfo", "creditCardInfo")) === true)
            {
                $status = "inactive";
                $errors[] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if(trim($name) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_NAME';
        };

        if(trim($cid) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_USERNAME';
        };

        if($mode != CAMTECH_MODE_PRODUCTION && $mode != CAMTECH_MODE_TEST)
        {
            $errors[] = 'MODULE_ERROR_INVALID_MODE';
        };

        if(empty($errors))
        {
            modApiFunc('Checkout', 'setModuleActive',
                modApiFunc('Payment_Module_Camtech_CC', 'getUid'),
                ($status == "active"));

            $settings = array(
                'MODULE_NAME' => $name
               ,'CAMTECH_MERCHANT_ID' => $cid
               ,'MODULE_MODE' => $mode
               ,'CAMTECH_PASSWORD' => $password
            );

            modApiFunc('Payment_Module_Camtech_CC', 'updateSettings',
                       $settings);
            $SessionPost = array(
                'ViewState' => array(
                    'hasCloseScript' => 'true'
                )
            );
        }
        else
        {
            $SessionPost = array(
                'ViewState' => array(
                    'ErrorsArray' => $errors
                   ,'hasCloseScript' => 'false'
                   ,'FormSubmitValue' => 'save'
                )
            );
        };

        $SessionPost['MODULE_NAME'] = $name;
        $SessionPost['MODULE_MODE'] = $mode;
        $SessionPost['CAMTECH_PASSWORD'] = $password;
        $SessionPost['CAMTECH_MERCHANT_ID'] = $cid;
        $SessionPost['status'] = $status;

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
};

?>