<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

//: move "defines" to member variables
//define("URL_CYBERBIT_ROUTINE", "https://www2.cyberbit.com/2co/buyer/purchase");
//TEST MODE URL
define("CYBERBIT_URL_TEST", "https://test.eccpro.com/securepayment/paymentstart.php");
//LIVE MODE URL
define("CYBERBIT_URL", "https://eccpro.com/securepayment/paymentstart.php");

/**
 *
 * @package PaymentModuleCyberbitCC.
 * @author Egor V. Derevyankin
 */
class Payment_Module_Cyberbit_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModulePaypal constructor.
     */
    function Payment_Module_Cyberbit_CC()
    {

        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cyberbit-messages", "AdminZone");

        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_CYBERBIT_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cyberbit-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_CYBERBIT_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_CYBERBIT_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     */
    function install()
    {
        global $application;

        $tables = Payment_Module_Cyberbit_CC::getTables();
        $query = new DB_Table_Create($tables);

        loadCoreFile('csv_parser.php');
        $csv_parser = new CSV_Parser();

        $table = 'pm_cyberbit_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        list($flt,$Default_Settings) = $csv_parser->parse_file(dirname(__FILE__)."/includes/default_settings.csv");
        if(count($Default_Settings) > 0)
        {
            foreach($Default_Settings as $key => $setting)
            {
                $query = new DB_Insert($table);
                $query->addInsertValue($setting["key"], $columns['key']);
                $query->addInsertValue(serialize($setting["value"]), $columns['value']);
                $application->db->getDB_Result($query);
            };
        };

        $columns = $tables['pm_cyberbit_currency']['columns'];

        list($flt, $Currencies) = $csv_parser->parse_file(dirname(__FILE__)."/includes/cb_currency.csv");
        if(count($Currencies) > 0)
        {
            foreach($Currencies as $key => $currency)
            {
                $query = new DB_Insert('pm_cyberbit_currency');
                $query->addInsertValue($currency["currency_scode"], $columns['currency_scode']);
                $query->addInsertValue($currency["currency_dcode"], $columns['currency_dcode']);
                $application->db->getDB_Result($query);
            };
        };

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               __CLASS__,
               'OnRemovePersonInfoType');

    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Cyberbit_CC                    1 PersonInfoType:
     * billingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-cyberbit-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_CYBERBIT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//	   return "7C4C4AA7-2E02-415E-8307-EA404C295061";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cyberbit-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleCyberbitCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleCyberbitCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleCyberbitCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_cyberbit_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_cyberbit_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_cyberbit_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_cyberbit_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }


	//----------------GET COUNTRY CODE--------------------------
	function get_countrycode($country)
	{
        $c_code = modApiFunc('Location','getCountryCodeByCountryName',$country);
		if($c_code=='')
		{
			$c_code='US';	//default country code;
		}
		return $c_code;
	}

//----------------GET STATE CODE--------------------------
	function get_statecode($state,$country_code)
	{
		if(($country_code=='CA') || ($country_code=='US'))
		{
            $s_code = modApiFunc('Location','getStateCodeByStateName',$state);
		}
        else
        {
            $s_code = '';
        };

		if($s_code=='')
		{
			$s_code='OO';	//default state code;
		}

		return $s_code;
	}


	//--------------GET CURRENCY CODE-------------------------
	function get_currencycode($currency)
	{
        global $application;
        $tables = $this->getTables();
        $currency_table = $tables['pm_cyberbit_currency']['columns'];

        $params = array(
                 "ApiClassName" => __CLASS__
                ,"arg_currency" => $currency
                ,"dcode" => $currency_table['currency_dcode']
                ,"scode" => $currency_table['currency_scode']
            );
        $result = execQuery('SELECT_PM_CYBERBIT_CURRENCY', $params);

//        $query = new DB_Select();
//        $query->addSelectTable('pm_cyberbit_currency');
//        $query->addSelectField($currency_table['currency_dcode'], 'dcode');
//        $query->WhereValue($currency_table['currency_scode'], DB_EQ, $currency);
//
//        $res = $application->db->getDB_Result($query);

		if(count($res) != 1)
		{
			return 840;	//default currency code;
		}
        else
        {
            return intval($res[0]['dcode']);
        };
	}

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {

        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_cyberbit_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_cyberbit_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {

        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $self_link = $request->getURL("", true);

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask("Shipping", "attr", AAL_CUSTOM_PARAM, "value");

        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

        $this->getSettings();
        $confirmationData = array
            (
                // "FormAction" => URL_CYBERBIT_ROUTINE
				"FormAction" => $this->Settings['MODULE_MODE'] == 1 ? CYBERBIT_URL_TEST : CYBERBIT_URL
                ,"FormMethod" => "POST"
				,"GatewayName" => "CYBERBIT"
                ,"DataFields" => array
                (
                    //
                    // common info
                    //----------------
                     "amount"             => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', '')*100
                     ,"orderid" => $orderId // should be an internal oder number in the system

                    ,"ownerfirstname" => $billingInfo->getByMask('Firstname')
					,"ownerlastname" => $billingInfo->getByMask('Lastname')
                    ,"ownerphone"            => $billingInfo->getByMask('Phone')// - buyers phone number (16 characters max)
                    ,"owneremail"            => $billingInfo->getByMask('Email')// - buyers email address (64 characters max)
                    ,"owneraddress"   => $billingInfo->getByMask('Streetline1')." ".$billingInfo->getByMask('Streetline2') // - buyers address (64 characters max)
                    ,"ownercity"             => $billingInfo->getByMask('City')// - buyers city (64 characters max)
                    ,"ownerstate"            => $this->get_statecode($billingInfo->getByMask('State'),$this->get_countrycode($billingInfo->getByMask('Country'))) // $billingInfo->getByMask('State') buyers state (64 characters max)
                    ,"ownerzip"              => $billingInfo->getByMask('Postcode')// - buyers zip code (16 characters max)
                   // ,"country"          => $billingInfo->getByMask('Country')// - buyers country (64 characters max)
                   	,"transtype" =>3
					,"code" =>$this->Settings["MODULE_SECRET"]
					,"accepturl" => $self_link
					,"callbackurl" => $self_link
					,"shopip" =>$_SERVER['REMOTE_ADDR']
					,"currencycode" =>$this->get_currencycode($currency)
					,"shopname" =>'your shop'
					,"ownercountrycode" =>$this->get_countrycode($billingInfo->getByMask('Country'))
					,"merchantid" =>$this->Settings["MODULE_ID"]
                )
            );

        return $confirmationData;
    }


    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
		global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-cyberbit-messages", "AdminZone");

        $result = array();

        $payment_processor_order_id = null;
        $need_log = false;

        loadCoreFile('obj_xml.php');
        if(isset($data["_POST"]["xml"]))
        {
            $parser = new xml_doc($data["_POST"]["xml"]);
            $parser->parse();
            foreach($parser->xml_index as $k => $tag)
            {
                if($tag->name == 'ECCPRO')
                {
                    foreach($tag->children as $eccpro_child)
                    {
                        if($eccpro_child->name == 'RESPONSE')
                        {
                            foreach($eccpro_child->children as $resp_child)
                            {
                                if($resp_child->name == 'PROCESSORDERID')
                                {
                                    $payment_processor_order_id = $resp_child->contents;
                                };
                            };
                        };
                    };
                };
            };
        }

        $order_info = modApiFunc("Checkout", "getOrderInfo", $order_id, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $order_id, $this->getUid()));

        if($order_info['PaymentProcessorOrderId'] != '')
        {
            $need_log = false;
        };

        if($payment_processor_order_id != null)
        {
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $payment_processor_order_id);
        };

        $status = $data["_POST"]["statuscode"];
        // the status update
        switch ($status)
        {
            case "000":
                    $EventType = "ConfirmationSuccess";
                    if($need_log)
                    {
                        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_CYBERBIT_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_CYBERBIT_LOG_MESSAGE_COMPLETED'));
                    };
                break;
            default:
                    $EventType = "ConfirmationFailure";
                    if($need_log)
                    {
                        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage("MODULE_PAYMENT_CYBERBIT_LOG_MESSAGE_MD5FAILURE"));
                    };
                break;
         }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Cyberbit_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_cyberbit_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_cyberbit_setting_id'
               ,'key'               => $settings.'.pm_cyberbit_setting_key'
               ,'value'             => $settings.'.pm_cyberbit_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        $table = 'pm_cyberbit_currency';
        $tables[$table] = array(
            'columns' => array(
                'currency_id'    => $table.'.cyrrency_id'
               ,'currency_scode' => $table.'.currency_scode'
               ,'currency_dcode' => $table.'.currency_dcode'
             )
           ,'types' => array(
                'currency_id'    => DBQUERY_FIELD_TYPE_INT . ' NOT NULL auto_increment'
               ,'currency_scode' => DBQUERY_FIELD_TYPE_CHAR5 . ' NOT NULL'
               ,'currency_dcode' => DBQUERY_FIELD_TYPE_INT . ' NOT NULL'
             )
           ,'primary' => array(
                'currency_id'
             )
           ,'indexes' => array(
                'IDX_scode' => 'currency_scode'
           )
        );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function getBodyOnLoad()
    {
        return "window.name = 'payment';document.forms['checkout'].submit()";
    }

    function getOrderIDFromXML($xml)
    {
        loadCoreFile('obj_xml.php');
        $parser = new xml_doc($xml);
        $parser->parse();
        foreach($parser->xml_index as $k => $tag)
        {
            if($tag->name == 'ECCPRO')
            {
                foreach($tag->children as $eccpro_child)
                {
                    if($eccpro_child->name == 'RESPONSE')
                    {
                        foreach($eccpro_child->children as $resp_child)
                        {
                            if($resp_child->name == 'RETURNINFO')
                            {
                                foreach($resp_child->children as $info_child)
                                {
                                    if($info_child->name == 'ORDERID')
                                    {
                                        return $info_child->contents;
                                    };
                                };
                            };
                        };
                    };
                };
            };
        };

        return null;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>