<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 *
 * @package PaymentModuleCybersourceCC
 * @author Alexander Belyakov
 */
class Payment_Module_Cybersource_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Payment_Module_Cybersource_CC constructor.
     */
    function Payment_Module_Cybersource_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_CYBERSOURCE_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_CYBERSOURCE_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_CYBERSOURCE_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Cybersource_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");

        $tables = Payment_Module_Cybersource_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_cybersource_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_GATEWAY_URL", $columns['key']);
        $query->addInsertValue('s:' . _ml_strlen($obj->getMessage('DEFAULT_GATEWAY_URL')) . ':"' . $obj->getMessage('DEFAULT_GATEWAY_URL') . '";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_HOP_FILE", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Cybersource_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Cybersource_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_CYBERSOURCE_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // CyberSource GUID
//        return "E9764DF6-7C72-424C-B355-BF67D1711F61";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleCybersourceCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleCybersourceCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleCybersourceCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_cybersource_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_cybersource_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_cybersource_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_cybersource_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_cybersource_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_cybersource_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Checks if the HOP.php file was properly installed
     * returns true or false
     */
    function isHopFileValid()
    {
        $settings = $this->getSettings();
        if (trim($settings["MODULE_HOP_FILE"]) == '')
            return false;

        if (!file_exists($settings["MODULE_HOP_FILE"]))
            return false;

        return true;
    }


    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');
        $settings = $this->getSettings();

        // check if there are the HOP.php API file is uploaded
        if (!$this->isHopFileValid())
        {
            return Array(); // if not, return an empty array
        }

        // include API file
        _use($settings["MODULE_HOP_FILE"]);

        // check if there are necessary functions present
        if (!function_exists("getMerchantID")
            || !function_exists("getPublicKey")
            || !function_exists("getSerialNumber")
            || !function_exists("hopHash"))
        {
            return Array(); // if not, return an empty array
        }

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');

        $orderPage_transactionType = "sale";
        $merchantId = getMerchantId();
        $publicKey = getPublicKey();
        $serialNumber = getSerialNumber();
        $timestamp = getmicrotime();

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $currency    = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                 $currency_id));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                   $currency_id));

    //=============================================================
    //=============================== checksum ====================
        $checksum_txt = $merchantId . $total . $currency . $timestamp . $orderPage_transactionType;
        $checksum = hopHash($checksum_txt, $publicKey);

    //==========================================================
    //====================== confirmation data =================
        $confirmationData = array
            (
                 "FormAction" => $settings["MODULE_GATEWAY_URL"]
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                     "orderNumber"      => $orderId
                    ,"asc_oid"          => $orderId
                    ,"merchantID"       => $merchantId
                    ,"orderPage_transactionType" => $orderPage_transactionType
                    ,"orderPage_timestamp"       => $timestamp
                    ,"orderPage_signaturePublic" => $checksum
                    ,"orderPage_version"         => "4"
                    ,"orderPage_serialNumber"    => $serialNumber
                    ,"billTo_firstName" => $billingInfo->getByMask("Firstname")
                    ,"amount"           => $total
                    ,"taxAmount"        => $tax
                    ,"currency"         => $currency
                    ,"billTo_lastName"  => $billingInfo->getByMask("Lastname")
                    ,"billTo_phoneNumber" => $billingInfo->getByMask('Phone')
                    ,"billTo_postalCode"  => $billingInfo->getByMask('Postcode')
                    ,"billTo_state"     => $bstate
                    ,"billTo_street1"   => $billingInfo->getByMask("Streetline1")
                    ,"billTo_street2"   => $billingInfo->getByMask("Streetline2")
                    ,"billTo_email"     => $billingInfo->getByMask('Email')
                    ,"billTo_city"      => $billingInfo->getByMask("City")
                    ,"billTo_country"   => $bcountry
                    ,"shipTo_firstName" => $shippingInfo->getByMask('Firstname')
                    ,"shipTo_lastName"  => $shippingInfo->getByMask("Lastname")
                    ,"shipTo_street1"   => $shippingInfo->getByMask("Streetline1")
                    ,"shipTo_street2"   => $shippingInfo->getByMask("Streetline2")
                    ,"shipTo_city"      => $shippingInfo->getByMask("City")
                    ,"shipTo_country"   => $scountry
                    ,"shipTo_postalCode" => $shippingInfo->getByMask('Postcode')
                    ,"shipTo_state"     => $sstate

                    ,"orderPage_sendMerchantURLPost"    => "true"
                    //,"orderPage_merchantURLPostAddress" => str_replace("https://", "http://", $self_link) ."&status=notify&CZSESSID=" . session_id()
		    ,"orderPage_merchantURLPostAddress" => $self_link ."&status=notify"//&CZSESSID=" . session_id()

                    ,"orderPage_declineLinkText"        => "decline"
                    ,"orderPage_declineResponseURL"     => $self_link ."&status=cancel"//&CZSESSID=" . session_id()

                    ,"orderPage_receiptLinkText"        => "back"
                    ,"orderPage_receiptResponseURL"     => $self_link ."&status=return"//&CZSESSID=" . session_id()

                    ,"orderPage_displayShipToFields" => "true"
                    ,"orderPage_displayBillToFields" => "true"
                 )
            );

        $msg = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $confirmationData);

        return $confirmationData;
    }

    /**
     * processNotify processes all the data got from the gateway
     * and sets order history accordingly
     *
     * @param array() $data
     * @param int $order_id
     */
    function processNotify($data, $order_id)
    {
        global $application;
        $mres = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");

        if (isset($data["decision"]))
            $decision = $data["decision"];
        else
            $decision = "ERROR";

        //================== AVS =================================
        if (isset($data["ccAuthReply_avsCode"]))
        {
            $avsCode = preg_replace("/[^ABCDEFGHIKLNOPRSTUVWXYZ12]/i", "2", $data["ccAuthReply_avsCode"]);
            $msg = $mres->getMessage("AVS_RESPONSE") . $data["ccAuthReply_avsCode"];
            $msg .= "\n" . $mres->getMessage("AVS_RESPONSE_" . $avsCode);
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }
        else
        {
            $msg = $mres->getMessage("AVS_NO_RESPONSE");
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }

        //================== CVV ==================================
        if (isset($data["ccAuthReply_cvCode"]))
        {
            $cvCode = preg_replace("/[^DIMNPSUX123]/i", "2", $data["ccAuthReply_cvCode"]);
            $msg = $mres->getMessage("CCV_RESPONSE") . $data["ccAuthReply_cvCode"];
            $msg .= "\n" . $mres->getMessage("CCV_RESPONSE_" . $cvCode);
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }
        else
        {
            $msg = $mres->getMessage("CCV_NO_RESPONSE");
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }

        //=================== Smart Auth Factor =========================
        if (isset($data["ccAuthReply_authFactorCode"]))
        {
            $afCode = preg_replace("/[^JMNOUX]/i", "", $data["ccAuthReply_authFactorCode"]);
            if (_ml_strlen($afCode) == 0)
            {
                $afCode = "0";
            }
            $msg = $mres->getMessage("AFC_RESPONSE") . $data["ccAuthReply_authFactorCode"];
            for ($i=0; $i < _byte_strlen($afCode); $i++)
            {
                $msg .= "\n" . $mres->getMessage("AFC_RESPONSE_" . $afCode[$i]);
            }
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }
        else
        {
            $msg = $mres->getMessage("AFC_NO_RESPONSE");
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }

        //=================== break [signedFields] apart =================
        if (isset($data["signedFields"]))
        {
            $data["signedFields"] = "[...]";
        }

        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $mres->getMessage('MODULE_PAYMENT_CYBERSOURCE_LOG_EVENT_DESCRIPTION') . " \n " . print_r($data, true);

        switch ($decision)
        {
            case "ACCEPT":
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
                break;

            case "REVIEW":
                $EventType = "ConfirmationSuccess";
                $msg .= "\n" . $mres->getMessage("MODULE_PAYMENT_CYBERSOURCE_LOG_REVIEW");
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
                break;

            case "REJECT":
            case "ERROR":
            default:
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
                break;
        }

        return $result;
    }

    /**
     * Processes data on updating the order status, that came from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, that came from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-cybersource-messages", "AdminZone");
        //the first step of data processing from the Payment Gateway
        //the payment status update.
        //the next step.
        //do not call the Payment Gateway .
        if (isset($data["_GET"]["status"]))
            $status = $data["_GET"]["status"];
        else
            $status = "int_error";

        switch ($status)
        {
            case "notify":
                $EventType = "BackgroundEvent";
                $result = $this->processNotify($data["_POST"], $order_id);
                break;

            case "return":
                $EventType = "ConfirmationSuccess";
                $msg = $obj->getMessage("MODULE_PAYMENT_CYBERSOURCE_CUSTOMER_RETURNED");
                $result = 1;
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
                break;

            case "cancel":
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                    $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_CYBERSOURCE_LOG_EVENT_DESCRIPTION') . " \n " . print_r($data["_POST"], true));
                break;

            default:
                //: Report Error: e.g. write to order history
                $result = array("payment_status" => array());
                break;
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Cybersource_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Cybersource_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_cybersource_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_cybersource_setting_id'
               ,'key'               => $settings.'.pm_cybersource_setting_key'
               ,'value'             => $settings.'.pm_cybersource_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    /**
     * Credit card info. It will be used later.
     */
    var $ccInfoCardNumber;
    var $ccInfoCardExpMonth;
    var $ccInfoCardExpYear;
    var $ccInfoCardIDNumber;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>