<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleEPDQCC
 * @author Egor V. Derevyankin
 *
 */

class CheckoutPaymentModuleEPDQCCInputAZ extends pm_sm_input_az
{
    function CheckoutPaymentModuleEPDQCCInputAZ()
    {
        global $application;
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_EPDQ_CC", "getSettings");
        $this->POST['sets'] = $settings;

        $this->POST["status"] = modApiFunc("Payment_Module_EPDQ_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_epdq/", "error.tpl.html", array());
        }
        return $result;
    }

    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_epdq/", "status.tpl.html", array());
        return $retval;
    }

    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_epdq");
        $form_action = $request->getURL();

        $ct_select = array(
            'select_name' => 'sets[CHARGE_TYPE]'
           ,'selected_value' => $this->POST['sets']['CHARGE_TYPE']
           ,'values' => array(
                array('value' => 'A', 'contents' => getMsg('PMEPDQ','CT_AUTH'))
               ,array('value' => 'P', 'contents' => getMsg('PMEPDQ','CT_PRE_AUTH'))
           )
        );

        $template_contents = array(
                                    "EditPMForm"            => $HtmlForm1->genForm($form_action, "POST", "EditPMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"Errors"                => $this->outputErrors()
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "sets[MODULE_NAME]", "75", prepareHTMLDisplay($this->POST['sets']["MODULE_NAME"]))
                                   ,"SetsCIDField"          => $HtmlForm1->genInputTextField("128", "sets[CLIENT_ID]", "75", prepareHTMLDisplay($this->POST['sets']["CLIENT_ID"]))
                                   ,"SetsPasswordField"     => $HtmlForm1->genInputTextField("128", "sets[PASSWORD]", "75", prepareHTMLDisplay($this->POST['sets']["PASSWORD"]))
                                   ,"SetsChargeTypeField"   => $HtmlForm1->genDropdownSingleChoice($ct_select)
                                   ,"SetsMDNField"          => $HtmlForm1->genInputTextField("128", "sets[MDN]", "75", prepareHTMLDisplay($this->POST['sets']["MDN"]))

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()
                                   );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_epdq/", "list.tpl.html", array());
    }

    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
                $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }

    var $POST;

    /**
     * View state structure. Comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. Comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;
};

?>