<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
 /*
  */

class EpnPayment {
    var $myGatewayURL;

    var $myEPNAccountNumber;
    var $myCardNo;
    var $myExpMonth;
    var $myExpYear;
    var $myTotal;
    var $myAddress;
    var $myZip;
    var $myEMail;
    var $myCVV2Type;
    var $myCVV2;

    var $myError;
    var $myErrorMessage;

    /***********************************************************************
     *** SET values to send to EPN                                       ***
     ***********************************************************************/
    function setEPNAccountNumber( $EPNAccountNumber ) {
        $this->myEPNAccountNumber = $EPNAccountNumber;
    }

    function setCardNo( $CardNo ) {
        $this->myCardNo = $CardNo;
    }

    function setExpMonth( $ExpMonth ) {
        $this->myExpMonth = $ExpMonth;
    }

    function setExpYear( $ExpYear ) {
        $this->myExpYear = $ExpYear;
    }

    function setTotal( $Total ) {
        $this->myTotal = $Total;
    }

    function setAddress( $Address ) {
        $this->myAddress = $Address;
    }

    function setZip( $Zip ) {
        $this->myZip = $Zip;
    }

    function setEMail( $EMail ) {
        $this->myEMail = $EMail;
    }

    function setCVV2Type( $CVV2Type ) {
        $this->myCVV2Type = $CVV2Type;
    }

    function setCVV2( $CVV2 ) {
        $this->myCVV2 = $CVV2;
    }

    /***********************************************************************
     *** GET values returned by EPN                                      ***
     ***********************************************************************/

    function parseResponse($response)
    {
        $settings = modApiFunc("Payment_Module_EPN_CC", "getSettings");

        if($settings['MODULE_MODE'] == EPN_MODE_TEST)
        {
            $pattern = '/\"([^\"]*)\",\"([^\"]*)\"/';
        }
    	else
    	{
	    	if($this->myCVV2Type == EPN_CVV2_SHOULD_BE_USED)
	    	{
	    		$pattern = '/\"([^\"]*)\",\"([^\"]*)\",\"([^\"]*)\"/';
	    	}
	    	else
	    	{
	            $pattern = '/\"([^\"]*)\",\"([^\"]*)\"/';
	    	}
    	}
    	$matches = array();
        if(preg_match($pattern, $response, $matches) == 1)
        {
            //successful match
	        $parseRes['TrxnMessage'] = $matches[1];
            $parseRes['TrxnStatus'] = _ml_substr($parseRes['TrxnMessage'], 0, 1);
	        $parseRes['AddressMessage'] = $matches[2];
	        if($this->myCVV2Type == EPN_CVV2_SHOULD_BE_USED && $settings['MODULE_MODE'] !== EPN_MODE_TEST)
	        {
	        	if(!empty($matches[3]))
	        	{
	                $parseRes['CVV2Message'] = $matches[3];
	        	}
	        	else
	        	{
	        		$parseRes['CVV2Message'] = "";
	        	}
	        }
	        else
	        {
	            $parseRes['CVV2Message'] = "";
	        }
	        return $parseRes;
        }
        else
        {
        	global $application;
            $MR = &$application->getInstance('MessageResources','payment-module-epn-messages','AdminZone');
            $msg = $MR->getMessage('MODULE_PAYMENT_EPN_MSG_ERROR_GATEWAY_RESPONSE_UNKNOWN_FORMAT');

        	return array
        	(
        	     "Error"        => EPN_ERROR_GATEWAY_RESPONSE_UNKNOWN_FORMAT
                ,"ErrorMessage" => $msg . ":'" . $response . "'."
        	);
        }
    }

    /***********************************************************************
     *** Class Constructor                                               ***
     ***********************************************************************/
    function EpnPayment( $EPNAccountNumber = EPN_DEFAULT_ACCOUNT_NUMBER, $gatewayURL = EPN_DEFAULT_GATEWAY_URL ) {
        $this->myEPNAccountNumber = $EPNAccountNumber;
        $this->myGatewayURL = $gatewayURL;
    }

    /***********************************************************************
     *** Business Logic                                                  ***
     ***********************************************************************/
    function doPayment() {

        $Request = array
        (
	         "ePNAccount" => $this->myEPNAccountNumber
	        ,"CardNo"     => $this->myCardNo
	        ,"ExpMonth"   => $this->myExpMonth
	        ,"ExpYear"    => $this->myExpYear
	        ,"Total"      => $this->myTotal
	        ,"Address"    => $this->myAddress
	        ,"Zip"        => $this->myZip
	        ,"EMail"      => $this->myEMail
	        ,"CVV2Type"   => $this->myCVV2Type
	        ,"CVV2"       => $this->myCVV2
            ,"HTML"       => "No"
        );


        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setURL($this->myGatewayURL);
        $bnc->setMethod('POST');
        $bnc->setPOSTstring($bnc->prepareDATAstring($Request));

        $result = $bnc->RunRequest();

        $this->myError = NULL;
        // Check whether the curl_exec worked.
        if( $result !== false) {
            $Response = $result["body"];

            $parseRes = $this->parseResponse($Response);

            if( !isset($parseRes["Error"]) ) {
                $this->myResultTrxnStatus     = $parseRes['TrxnStatus'];
                $this->myResultTrxnMessage    = $parseRes['TrxnMessage'];
                $this->myResultAddressMessage = $parseRes['AddressMessage'];
                $this->myResultCVV2Message    = $parseRes['CVV2Message'];
            } else {
                // parse error occured. Return the error message and number.
                $this->myError        = $parseRes["Error"];
                $this->myErrorMessage = $parseRes["ErrorMessage"];
            }
        } else {

            $this->myError        = $bnc->errno;
            $this->myErrorMessage = $bnc->errstr;
        }

        if($this->myError !== NULL)
        {
        	return array
        	(
        	    "Error"        => $this->myError
        	   ,"ErrorMessage" => $this->myErrorMessage
        	   ,"RawGatewayResponse" => empty($Response) ? "" : $Response
        	);
        }
        else
        {
        	return array
        	(
                 'TrxnStatus'     => $parseRes['TrxnStatus']
                ,'TrxnMessage'    => $parseRes['TrxnMessage']
                ,'AddressMessage' => $parseRes['AddressMessage']
                ,'CVV2Message'    => $parseRes['CVV2Message']
                ,"RawGatewayResponse" => empty($Response) ? "" : $Response
        	);
        }
    }
}
?>