<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Checkout module.
 * Action handler on UpdatePaymentStatus.
 *
 * @package Checkout
 * @access  public
 */
class GoogleUpdatePaymentStatus
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     *
     * @ finish the functions on this page
     */
    function GoogleUpdatePaymentStatus()
    {
    }

    /**
     * Updates the payment status for the given order. According to information
     * from the payment gateway.
     *
     * Action: UpdatePaymentStatus.
     *
     * @ finish the functions on this page
     */
    function onAction()
    {
        global $application;

        $xml_response = $_POST;
        if (isset($xml_response['google-order-number']))
        {
            $google_oid = $xml_response['google-order-number'];
        }
        else
        {
            exit();
        }

        $asc_oid = modApiFunc("Payment_Module_Google_CC", "GetAvactisOrderId", $google_oid);
        if (!$asc_oid)
        {
            if (isset($xml_response['shopping-cart_items_item-1_merchant-item-id']))
            {
                $asc_oid = $xml_response['shopping-cart_items_item-1_merchant-item-id'];
                modApiFunc("Payment_Module_Google_CC", "AddOrdersLink", $google_oid, $asc_oid);
            }
        }

    //=========================== logging xml_response ========================

        $logged_resp = $xml_response;
        $logged_resp['avactis_computed_asc_oid'] = $asc_oid;
        $msgObj = $application->getInstance("MessageResources", "payment-module-google-messages", "AdminZone");
        modApiFunc('Payment_Module_Google_CC', 'addRequestLog', "LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_UPDATE_PAYMENT_STATUS_RESPONSE").$asc_oid, prepareArrayDisplay($logged_resp));

    //=========================== logging xml_response ========================

        $state = NULL;
        if (isset($xml_response['financial-order-state']))
        {
            $state = $xml_response['financial-order-state'];
        }
        elseif (isset($xml_response['new-financial-order-state']))
        {
            $state = $xml_response['new-financial-order-state'];
        }

        if ($state)
        {
            $request = new Request();
            $request->setView('Checkout');
            $request->setAction('UpdatePaymentStatus');
            $request->setKey('asc_oid',$asc_oid);
            $request->setKey('trans_key',$google_oid);
            $request->setKey('order-state',$state);
            $application->redirect($request);
        }
        else
        {
            exit();
        }
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**#@-*/
}

?>