<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
*
* @package PaymentModuleGoogleCC
* @author Leonid
*/

define("GOOGLE_CURRENCY", "USD");

define("SANDBOX_URL", "sandbox.google.com/checkout");
define("PRODUCTION_URL", "checkout.google.com");

/*Include modules to form post raw data*/
//chdir("..");
require_once(dirname(__FILE__).'/library/googlecart.php');
require_once(dirname(__FILE__).'/library/googleitem.php');
require_once(dirname(__FILE__).'/library/googleshipping.php');
require_once(dirname(__FILE__).'/library/googletaxrule.php');
require_once(dirname(__FILE__).'/library/googletaxtable.php');

class Payment_Module_Google_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModuleGoogle constructor.
     */

    function Payment_Module_Google_CC()
    {
        global $application;
        $this->MessageResourses = &$application->getInstance('MessageResources',"payment-module-google-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" .

        $this->Settings["MODULE_NAME"]. "\n".$this->getmicrotime()."\n";

    }


    function getmicrotime()
    {
        list($usec, $sec) = explode(" ",microtime());

        return $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_SECONDS');
    }


    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Google_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-google-messages", "AdminZone");

        $tables = Payment_Module_Google_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_google_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table


        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_KEY", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Google_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Google_CC                    1 PersonInfoType:
     * billingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-google-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_GOOGLE_CHECKOUT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }




    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "36EE5285-6781-B365-804A-BFFEF9272EBF";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$this->MessageResourses->getMessage('MODULE_STATUS_ACTIVE')."</span>":$this->MessageResourses->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "google_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleGoogleCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleGoogleCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_google_settings');
        $application->db->getDB_Result($query);
    }


    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_google_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_google_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_google_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_google_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_google_settings');
            $query->addUpdateValue($columns['value'], serialize(trim($value)));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }


    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }


    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }


    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($order_id)
    {
        global $application;
        $data_logged = array();

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $order_id);
        $self_link = $request->getURL("", true);

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $order_id, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $order_id, $currency_id);
        $country_code = modApiFunc("Location", "getCountryCodeByCountryName" ,$orderInfo['Billing']['attr']['Country']['value']);

        $this->getSettings();

        $cart =  new GoogleCart($this->Settings["MODULE_MERCHANT_ID"], $this->Settings["MODULE_MERCHANT_KEY"], (intval($this->Settings["MODULE_MODE"])==1)?"sandbox":"checkout");

    //==== logging ====
        $data_logged['settings'] = $this->Settings;
    //==== logging ====

        //order_id is written as private_data in item
        foreach ($orderInfo["Products"] as $productInfo)
        {
            $item = new GoogleItem($productInfo["name"], $productInfo["ShortDescription"], $productInfo["qty"], $productInfo["SalePrice"],$currency,$orderInfo['ID']);
            $cart->AddItem($item);
        //==== logging ====
            $data_logged['items'][] = $item;
        //==== logging ====
        }

        $discount = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountsSum", $currency_id));
        if ($discount != 0)
        {
            $DiscountInfo = array();
            $DiscountInfo["name"] = "Discount";
            $DiscountInfo["ShortDescription"] = "Coupons and Discounts";
            $DiscountInfo["qty"] = 1;
            $DiscountInfo["SalePrice"] = -1*$discount;
            $DiscountInfo["Currency"]=$currency;
            $item = new GoogleItem($DiscountInfo["name"], $DiscountInfo["ShortDescription"], $DiscountInfo["qty"], $DiscountInfo["SalePrice"],$DiscountInfo["Currency"],"");
            $cart->AddItem($item);
        //==== logging ====
            $data_logged['discount'] = $item;
        //==== logging ====
        }

        $tax = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "NotIncludedTax", $currency_id));
        if ($tax != 0)
        {
            $subtotal = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Subtotal", $currency_id));
            $tax_rate = $tax/($subtotal - $discount);
            $tax = array();
            $tax['type'] = "default";
            $tax['tax_rules_arr'] = array();
            $tax['tax_rules_arr']['shipping_taxed'] = "false";
            $tax['tax_rules_arr']['tax_rate'] = $tax_rate;
            $tax['tax_rules_arr']['country_code'] = $country_code;
            $cart->AddTaxTables($tax);
        //==== logging ====
            $data_logged['tax'] = $tax;
        //==== logging ====
        }

        $ship = array();
        if (isset($orderInfo['ShippingMethod']))
        {
          $ship['name'] = "Shipping and Handling";
          $ship['type'] = "flat-rate";
          $ship['currency'] = $currency;
          $ship['price'] = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currency_id));
          if ( isset($ship['price']))
          {
                $cart->AddShipping($ship);
            //==== logging ====
                $data_logged['shippingMethod'] = $ship;
            //==== logging ====
          }
        }

        $post_data = $cart->CheckoutButtonCode("large");

        $confirmationData = array
        (
            //"FormAction" => $self_link,
            "FormMethod" => "POST"
           ,"DataFields" => array
            (
                "cart"           => $post_data["cart"]
               ,"signature"     => $post_data["signature"]
            )
         );

        $confirmationData['FormAction'] = "https://".( intval($this->Settings['MODULE_MODE']) == 1 ? SANDBOX_URL:PRODUCTION_URL). "/cws/v2/Merchant/".$this->Settings["MODULE_MERCHANT_ID"]."/checkout";

    //=========================== logging confirmation data ========================

        $data_logged['confirmationData'] = $confirmationData;
        $msgObj = $application->getInstance("MessageResources", "payment-module-google-messages", "AdminZone");
        $title = $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_GET_CONFIRMATION_DATA");
        $title = str_replace('{ORDER_ID}', $order_id, $title);
        modApiFunc('Payment_Module_Google_CC', 'addRequestLog', "LOG_PM_INPUT", "Payment Module Logs", $title, prepareArrayDisplay($data_logged));

    //=========================== logging confirmation data ========================

        return $confirmationData;
    }


    /**
     * Processes data on updating the order status come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;

    //=========================== logging process data ========================

        $msgObj = $application->getInstance("MessageResources", "payment-module-google-messages", "AdminZone");
        $title = $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_PROCESS_DATA");
        $title = str_replace('{ORDER_ID}', $order_id, $title);
        modApiFunc('Payment_Module_Google_CC', 'addRequestLog', "LOG_PM_INPUT", "Payment Module Logs", $title, prepareArrayDisplay($data));

    //=========================== logging process data ========================

        $EventType = "BackgroundEvent";
        $result = array();
        if (isset($data["_GET"]['trans_key']))
        {
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $data["_GET"]['trans_key']);
        }
        if (isset($data["_GET"]['order-state']))
        {
            $state = $data["_GET"]['order-state'];
            $this->OrderHistoryMessageTag.= $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_LOG_NEW_FINANCIAL_ORDER_STATE').
                                $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_STATE_'.$state)."\n".
                                $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_LOG_NEW_FINANCIAL_ORDER_STATE_DESCRIPTION').
                                $this->MessageResourses->getMessage('PAYMENT_MODULE_GOOGLE_STATE_'.$state.'_DESCR');

            switch ($state)
            {
                case 'REVIEWING':
                case 'CHARGEABLE':
                case 'CHARGING':
                    //waiting
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1, $this->OrderHistoryMessageTag);
                    break;
                case 'CHARGED':
                    //fully paid
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $this->OrderHistoryMessageTag);
    //                modApiFunc("Payment_Module_Google_CC", "RemoveOrdersLink", $data["_GET"]['trans_key']);
                    break;
                case 'PAYMENT_DECLINED':
                case 'CANCELLED':
                case 'CANCELLED_BY_GOOGLE':
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $this->OrderHistoryMessageTag);
    //                modApiFunc("Payment_Module_Google_CC", "RemoveOrdersLink", $data["_GET"]['trans_key']);
                    break;
            }
        }
        return array("EventType" => $EventType, "statusChanged" => $result);
    }


    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Google_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Google_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    function GetAvactisOrderId($GoogleOrderId)
    {
        global $application;
        $tables = $this->getTables();
        $o = $tables['pm_google_orders']['columns'];

        if ($GoogleOrderId)
        {
            $query = new DB_Select();
            $query->addSelectTable('pm_google_orders');
            $query->addSelectField($o['asc_oid'], 'asc_oid');
            $query->WhereValue($o['google_oid'], DB_EQ, $GoogleOrderId);
            $result = $application->db->getDB_Result($query);
            return $result[0]['asc_oid'];
        }
        else
        {
            return false;
        }
    }

    function AddOrdersLink($GoogleOrderId,$AvactisOrderId)
    {
        global $application;
        $tables = $this->getTables();
        $o = $tables['pm_google_orders']['columns'];

        if (($AvactisOrderId) && ($GoogleOrderId))
        {
            $query = new DB_Insert('pm_google_orders');
            $query->addInsertValue($AvactisOrderId, $o['asc_oid']);
            $query->addInsertValue($GoogleOrderId, $o['google_oid']);
            $application->db->getDB_Result($query);
            $result = $application->db->getDB_Result($query);
            return true;
        }
        else
        {
            return false;
        }
    }

    function RemoveOrdersLink($GoogleOrderId)
    {
        global $application;
        $tables = $this->getTables();
        $o = $tables['pm_google_orders']['columns'];

        if ($GoogleOrderId)
        {
            $db_delete = new DB_Delete('pm_google_orders');
            $db_delete->WhereValue($o['google_oid'], DB_EQ, $GoogleOrderId);
            $application->db->PrepareSQL($db_delete);
            $application->db->DB_Exec();
            return true;
        }
        else
        {
            return false;
        }
    }

    /*
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_google_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_google_setting_id'
               ,'key'               => $settings.'.pm_google_setting_key'
               ,'value'             => $settings.'.pm_google_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }
    */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $status = 'pm_google_orders';
        $tables[$status] = array();
        $tables[$status]['columns'] = array
            (
                'id'                => $status.'.id'
               ,'google_oid'        => $status.'.google_order_id'
               ,'asc_oid'           => $status.'.avactis_order_id'
            );
         $tables[$status]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'google_oid'        => DBQUERY_FIELD_TYPE_CHAR20 .' NOT NULL'
               ,'asc_oid'           => DBQUERY_FIELD_TYPE_CHAR20 .' NOT NULL'
            );
        $tables[$status]['primary'] = array
            (
                'id'
            );

        $settings = 'pm_google_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_google_setting_id'
               ,'key'               => $settings.'.pm_google_setting_key'
               ,'value'             => $settings.'.pm_google_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );


        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**
     * The flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>