<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * CheckoutPaymentModuleGoogleCCOutput view
 *
 * @package PaymentModuleGoogleCC
 * @author Vadim Lyalikov
 */
class CheckoutPaymentModuleGoogleCCOutput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *                                                     .
     */
    function getTemplateFormat()
    {
    	$format = array(
    	    'layout-file'        => "checkout-payment-module-google-cc-output-config.ini" //; $this->LayoutFile
    	   ,'files' => array(
    	        'OutputContainer'               => TEMPLATE_FILE_SIMPLE
    	    )
    	   ,'options' => array(
    	    )
    	);
    	return $format;
    }

    /**
     *  CheckoutPaymentModuleGoogleCCOutput constructor
     */
    function CheckoutPaymentModuleGoogleCCOutput()
    {
        global $application;

        #
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }
    }

    /**
     *
     */
    function output()
    {
        global $application;

//        $application->registerAttributes(array('PaymentHTMLModuleDescription' => $this->getTag("PaymentHTMLModuleDescription"),
//                                               'OutputField' => $this->getTag("OutputField")));

        $application->registerAttributes(array("Local_PaymentMethodName" => "", "Local_GoogleCheckoutButton" => ""));


        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        $retval = $this->templateFiller->fill("OutputContainer");
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {
            case 'Local_PaymentMethodName':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $value = $ModuleInfo['Name'];
                break;

            case 'Local_GoogleCheckoutButton':
                $ModuleSettings = modApiFunc($this->ModuleAPIClassName, "getSettings");
                $value = "<input type='image' name='Google Checkout' alt='Fast checkout through Google' src='https://".(intval($ModuleSettings['MODULE_MODE']) == 1 ? SANDBOX_URL:PRODUCTION_URL)."/buttons/checkout.gif?merchant_id=".$ModuleSettings['MODULE_MERCHANT_ID']."&amp;w=180&amp;h=46&amp;style=white&amp;variant=text&amp;loc=en_US' height='46' width='180'>";
                break;

            default:
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $ModuleAPIClassName = "Payment_Module_Google_CC";
    var $BlockTemplateName = "CheckoutPaymentModuleGoogleCCOutput";
    var $LayoutFile = "checkout-payment-module-google-cc-output-config.ini";
    /**#@-*/

}
?>