<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleIDEALCC
 * @author Egor V. Derevyankin
 *
 */

class ideal_load_rsa_keys
{
    function ideal_load_rsa_keys()
    {}

    function onAction()
    {
        global $_RESULT;
        $_errs = array();

        $request = new Request();
        $keys_source = $request->getValueByKey('rsa_keys_source');
        $sets_PRIV_PASS = $request->getValueByKey('sets_PRIV_PASS');

        switch($keys_source)
        {
            case 'local':
                $errors = array();
                $priv_key_res = modApiFunc('Payment_Module_IDEAL_CC','moveUploadedFileToKeysDir','sets_PRIV_KEY');
                $priv_cert_res = modApiFunc('Payment_Module_IDEAL_CC','moveUploadedFileToKeysDir','sets_PRIV_CERT');

                if($priv_key_res['error'] != UPLOAD_ERR_OK)
                {
                    $errors[] = 'ERROR_INVALID_PRIV_KEY';
                    $errors[] = $priv_key_res['error'];
                };

                if($priv_cert_res['error'] != UPLOAD_ERR_OK)
                {
                    $errors[] = 'ERROR_INVALID_PRIV_CERT';
                    $errors[] = $priv_cert_res['error'];
                };

                if($priv_key_res['error'] == UPLOAD_ERR_OK and $priv_cert_res['error'] == UPLOAD_ERR_OK)
                {
                    if(!modApiFunc('Payment_Module_IDEAL_CC','checkPrivateKeyAndCert',
                        $priv_key_res['full_path'], $priv_cert_res['full_path'], $sets_PRIV_PASS))
                    {
                        $errors[] = 'ERROR_INVALID_PRIV_KEY_PASS_CERT';
                    };
                };

                if(empty($errors))
                {
                    $sets = array(
                        'PRIV_KEY' => $priv_key_res['base_name']
                       ,'PRIV_PASS' => $sets_PRIV_PASS
                       ,'PRIV_CERT' => $priv_cert_res['base_name']
                    );
                    modApiFunc('Payment_Module_IDEAL_CC','updateSettings',$sets);
                }
                else
                {
                    global $application;
                    $MR = &$application->getInstance('MessageResources','payment-module-ideal-messages','AdminZone');
                    foreach($errors as $_error)
                    {
                        $_errs[] = is_int($_error) ? modApiFunc('Shell','getMsgByErrorCode',$_error) : $MR->getMessage($_error);
                    };
                };
                break;

            case 'gen':
                $gen_res = modApiFunc('Payment_Module_IDEAL_CC','generateKeys',$sets_PRIV_PASS);

                if ($gen_res['error'] === 0)
                {
                    $sets = array(
                        'PRIV_KEY' => $gen_res['key']
                       ,'PRIV_PASS' => $sets_PRIV_PASS
                       ,'PRIV_CERT' => $gen_res['cert']
                    );
                    modApiFunc('Payment_Module_IDEAL_CC','updateSettings',$sets);
                }
                else
                {
                    $_errs[] = $gen_res['error'];
                };
                break;

            default:
                global $application;
                $MR = &$application->getInstance('MessageResources','payment-module-ideal-messages','AdminZone');
                $_errs[] = $MR->getMessage('ERROR_UNKNOWN_KEYS_SOURCE');
                break;
        };

        $_RESULT['errors'] = array("errrrrrr");//$_errs;
    }
};

?>