<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleIDEALCC
 * @author Egor V. Derevyankin
 *
 */

class CheckoutPaymentModuleIDEALCCInputAZ extends pm_sm_input_az
{
    function CheckoutPaymentModuleIDEALCCInputAZ()
    {
        global $application;
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        loadCoreFile('html_form.php');
    }

    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_IDEAL_CC", "getSettings");
        $this->POST['sets'] = $settings;

        $this->POST["status"] = modApiFunc("Payment_Module_IDEAL_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );

        $this->ErrorsArray = modApiFunc('Payment_Module_IDEAL_CC','checkRequirments');
    }

    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = getMsg('PMIDEAL',$error);
            $result .= $this->mTmplFiller->fill("payment_module_ideal/", "error.tpl.html", array());
        }
        return $result;
    }

    function outputStatus()
    {
        global $application;
        $retval = "";

        $keys_correct = modApiFunc('Payment_Module_IDEAL_CC','areCurrentKeysCorrect');

        $suffix = $keys_correct ? '' : ' disabled';
        $status = $keys_correct ? $this->POST["status"] : false;

        $this->_Template_Contents = array(
                                          "Active"          => (($status)? "checked" : "").$suffix
                                         ,"Inactive"        => (($status)? "" : "checked").$suffix
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_ideal/", "status.tpl.html", array());
        return $retval;
    }

    function outputManageKeysForm()
    {
        global $application;

        $keys_correct = modApiFunc('Payment_Module_IDEAL_CC','areCurrentKeysCorrect');

        $r = new Request();
        $r->setView(CURRENT_REQUEST_URL);
        $r->setAction('ideal_rsa_keys_operation');

        $template_contents = array(
            "KeysNotDefinedDisplay" => $keys_correct ? 'none' : ''
           ,"KeysDefinedDisplay" => $keys_correct ? '' : 'none'
           ,"KeysOperationFormAction" => $r->getURL()
        );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_ideal/", "rsa-keys.tpl.html", array());
    }

    function output()
    {
        global $application;

        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        if(!function_exists('openssl_open'))
        {
            $template_contents = array(
                                        "Errors"                => $this->outputErrors()
                                      );

            $this->_Template_Contents = $template_contents;
            $application->registerAttributes($this->_Template_Contents);
            return $this->mTmplFiller->fill("payment_module_ideal/", "no-openssl.tpl.html", array());
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_ideal");
        $form_action = $request->getURL();

        $tt_select = array(
            'select_name' => 'sets[TRNS_MODE]'
           ,'selected_value' => $this->POST['sets']['TRNS_MODE']
           ,'values' => array(
                array('value' => PM_IDEAL_TRNS_MODE_TEST, 'contents' => getMsg('PMIDEAL','TRNS_MODE_TEST'))
               ,array('value' => PM_IDEAL_TRNS_MODE_PRODUCTION, 'contents' => getMsg('PMIDEAL','TRNS_MODE_PRODUCTION'))
           )
        );

        $template_contents = array(
                                    "EditPMForm"            => HtmlForm::genForm($form_action, "POST", "EditPMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"Errors"                => $this->outputErrors()
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameField"       => HtmlForm::genInputTextField("128", "sets[MODULE_NAME]", "70", prepareHTMLDisplay($this->POST['sets']["MODULE_NAME"]))
                                   ,"SetsMIDField"          => HtmlForm::genInputTextField("128", "sets[MERCHANT_ID]", "70", prepareHTMLDisplay($this->POST['sets']["MERCHANT_ID"]))
                                   ,"SetsSIDField"          => HtmlForm::genInputTextField("128", "sets[SUB_ID]", "70", prepareHTMLDisplay($this->POST['sets']["SUB_ID"]))
                                   ,"SetsTrnsTypeField"     => HtmlForm::genDropdownSingleChoice($tt_select)
                                   ,"ManageKeysForm"        => $this->outputManageKeysForm()
                                   ,"TrnsModeTestChecked"   => $this->POST['sets']['TRNS_MODE'] == PM_IDEAL_TRNS_MODE_TEST ? 'checked' : ''
                                   ,"TrnsModeProductionChecked" => $this->POST['sets']['TRNS_MODE'] == PM_IDEAL_TRNS_MODE_PRODUCTION ? 'checked' : ''
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_ideal/", "list.tpl.html", array());
    }

    function getTag($tag)
    {
        global $application;
        $value = "";

        switch($tag)
        {
            case 'Error':
                $value = $this->_error;
                break;
            case 'ErrorIndex':
                $value = $this->_error_index;
                break;
            default:
                $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
                break;
        };

        return $value;
    }

    var $POST;

    /**
     * View state structure. Comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. Comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $_error_index;
    var $_error;
};

?>