<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update Linkpoint settings.
 *
 * @package PaymentModuleLinkpoint CC
 * @access  public
 * @author Ravil Garafutdinov
 */
class update_linkpoint extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_linkpoint()
    {
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Linkpoint_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

//        $hostname = parse_url($SessionPost["GatewayUrl"]);
        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
                         ,"MERCHANT_CODE" => intval($SessionPost["MerchantCode"])
                         ,"GATEWAY_URL" => $SessionPost["GatewayUrl"]
                         ,"GATEWAY_PORT" => intval($SessionPost["GatewayPort"])
                         );
        if (isset($SessionPost["ModuleCertificate"]) && $SessionPost["ModuleCertificate"] != '')
        {
            $Settings["MODULE_CERTIFICATE"] = $SessionPost["ModuleCertificate"];
        }
        modApiFunc("Payment_Module_Linkpoint_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if(empty($SessionPost["ModuleName"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleName"] = new ActionMessage(array("ALERT_001_PHP"));
                }
                if(empty($SessionPost["MerchantCode"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["MerchantCode"] = new ActionMessage(array("ALERT_002_PHP"));
                }

                if (isset($_FILES["ModuleCertificate"])
                    && $_FILES["ModuleCertificate"]['tmp_name'])
                {
                    if ($_FILES["ModuleCertificate"]['size'] > 0
                        && filesize($_FILES["ModuleCertificate"]['tmp_name']) != FALSE)
                    {
                            $file_name = $application->getAppIni('PATH_MODULES_DIR')."payment_module_linkpoint_cc/certificate/".$_FILES["ModuleCertificate"]["name"];
                            @chmod(dirname($file_name), 0777);
                            if (@move_uploaded_file($_FILES["ModuleCertificate"]['tmp_name'], $file_name))
                            {
                                @chmod($file_name, 0644);
                                $SessionPost["ModuleCertificate"] = $file_name;
                            }
                            else
                            {
                                $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_CERTIFICATE_ERROR';
                            }
                            @chmod(dirname($file_name), 0755);
                    }
                    else
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_CERTIFICATE_ERROR';
                    }
                }
                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>