<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update Moneybooewallet settings.
 *
 * @package PaymentModuleMoneybooewalletCC
 * @access  public
 * @author Ravil Garafutdinov
 */
class update_moneybooewallet extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_moneybooewallet()
    {
    }


    function saveDataToDB($SessionPost)
    {
        $moduleUid = modApiFunc("Payment_Module_Moneybooewallet_CC", "getUid");
        if (!defined('DEMO_MODE'))
        {
            modApiFunc("Checkout", "setModuleActive", $moduleUid, ($SessionPost["status"]=="active")? true:false);
        }

        $current = modApiFunc('Payment_Module_Moneybooewallet_CC', 'getSettings');

        if (!isset($SessionPost["ModuleMerchantEmailValidated"]))
        {
            $SessionPost["ModuleMerchantEmailValidated"] = $current['MODULE_MERCHANT_EMAIL_VALIDATED'];
        }
        if (!isset($SessionPost["ModuleCustomerId"]))
        {
            $SessionPost["ModuleCustomerId"] = $current['MODULE_CUSTOMER_ID'];
        }
        if (!isset($SessionPost["ModuleSecretStringValidated"]))
        {
            $SessionPost["ModuleSecretStringValidated"] = $current['MODULE_SECRET_STRING_VALIDATED'];
        }

        if ($current['MODULE_MERCHANT_EMAIL'] != $SessionPost["ModuleMerchantEmail"])
        {
            $SessionPost["ModuleMerchantEmailValidated"] = '0';
            $SessionPost["ModuleCustomerId"] = '';
            $SessionPost["ModuleSecretStringValidated"] = '0';
        }

        if ($current['MODULE_SECRET_STRING'] != $SessionPost["ModuleSecretString"])
        {
            $SessionPost["ModuleSecretStringValidated"] = '0';
        }

        $Settings = array
            (
                 "MODULE_NAME"              => $SessionPost["ModuleName"]
                ,"MODULE_MERCHANT_NAME"     => $SessionPost["ModuleMerchantName"]
                ,"MODULE_MERCHANT_EMAIL"    => $SessionPost["ModuleMerchantEmail"]
                ,"MODULE_MERCHANT_EMAIL_VALIDATED" => $SessionPost["ModuleMerchantEmailValidated"]
                ,"MODULE_CUSTOMER_ID"       => $SessionPost["ModuleCustomerId"]
                ,"MODULE_SECRET_STRING"     => trim(strtolower($SessionPost["ModuleSecretString"]))
                ,"MODULE_SECRET_STRING_VALIDATED" => $SessionPost["ModuleSecretStringValidated"]
                ,"MODULE_LOGO_URL"          => $SessionPost["ModuleLogoUrl"]
                ,"MODULE_HIDE_LOGIN"        => $SessionPost["ModuleHideLogin"]
                ,"MODULE_URL"               => $SessionPost["ModuleUrl"]
                ,"MODULE_LANGUAGE"          => $SessionPost["ModuleLanguage"]
            );

        modApiFunc("Payment_Module_Moneybooewallet_CC", "updateSettings", $Settings);

        $new_settings = modApiFunc('Payment_Module_Moneybooewallet_CC', 'getSettings');
        if ($new_settings['MODULE_MERCHANT_EMAIL'] != ''
            && $new_settings['MODULE_MERCHANT_EMAIL_VALIDATED'] == '1'
            && $new_settings['MODULE_SECRET_STRING'] != ''
            && $new_settings['MODULE_SECRET_STRING_VALIDATED'] == '1'
            && $new_settings['MODULE_CUSTOMER_ID'] != '')
        {
            //modApiFunc("Checkout", "setModuleActive", $moduleUid, ($SessionPost["status"]=="active")? true:false);
        }
        else
        {
            modApiFunc("Checkout", "setModuleActive", $moduleUid, false);
        }
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                //$nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if (modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) !== true)
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (empty($SessionPost["ModuleMerchantEmail"]) == true || trim($SessionPost["ModuleMerchantEmail"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_MERCHANT_EMAIL";
                }
                if (empty($SessionPost["ModuleUrl"]) == true || trim($SessionPost["ModuleUrl"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_URL";
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if ($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            case "checkEmail":
            {
                if (empty($SessionPost["ModuleMerchantEmail"]) == true || trim($SessionPost["ModuleMerchantEmail"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_MERCHANT_EMAIL";
                }
                else
                {
                    loadCoreFile('bouncer.php');

                    $merchantEmail = urlencode($SessionPost["ModuleMerchantEmail"]);
                    $avactisCustomer = '14059669';
                    $avactisPassword = '43d437ede82fc7a7d1a6b69ae3c2152a';

                    $bnc = new Bouncer();
                    $bnc->setMethod('POST');
                    $bnc->setURL("https://www.moneybookers.com/app/email_check.pl");
                    $bnc->setPOSTstring("email=$merchantEmail&cust_id=$avactisCustomer&password=$avactisPassword");

                    $result = $bnc->RunRequest();

                    $success = false;
                    $cust_id = '';
                    if (isset($result['body']))
                    {
                        $body = explode(',', $result['body']);
                        if ($body[0] === 'OK' && isset($body[1]) && intval($body[1]) != 0)
                        {
                            $success = true;
                            $cust_id = intval($body[1]);
                        }
                    }

                    if ($success)
                    {
                        unset($SessionPost["ViewState"]["ErrorsArray"]);
                        modApiFunc("Payment_Module_Moneybooewallet_CC", "saveEmailAndCustomerId", $SessionPost["ModuleMerchantEmail"], $cust_id);
                    }
                    else
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_COULD_NOT_VALIDATE_EMAIL";
                    }
                }
                break;
            }
            case "checkSecretString":
            {
                if (empty($SessionPost["ModuleSecretString"]) == true || trim($SessionPost["ModuleSecretString"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_SECRET_STRING";
                }
                else
                {
                    loadCoreFile('bouncer.php');

                    $merchantEmail = urlencode($SessionPost["ModuleMerchantEmail"]);
                    $merchantSW = strtolower($SessionPost["ModuleSecretString"]);
                    $SessionPost["ModuleSecretString"] = $merchantSW;
                    $avactisCustomer = '14059669';
                    $avactisPassword = md5('avactis');//'43d437ede82fc7a7d1a6b69ae3c2152a';
//_print(md5('m0ney1'));
                    $secret = (md5($merchantSW)).$avactisPassword;
                    $secret = md5($secret);
//_print(md5('avactis'));
//_print(md5('m0ney1').md5('avactis'));
//_print(md5(md5('m0ney1').md5('avactis')));
                    $bnc = new Bouncer();
                    $bnc->setMethod('POST');
                    $bnc->setURL("https://www.moneybookers.com/app/secret_word_check.pl");
                    $bnc->setPOSTstring("email=$merchantEmail&cust_id=$avactisCustomer&secret=$secret");
//_print("https://www.moneybookers.com/app/secret_word_check.pl?email=$merchantEmail&cust_id=$avactisCustomer&secret=$secret");die;
                    $result = $bnc->RunRequest();

                    if (isset($result['body']) && $result['body'] === 'OK')
                    {
                        unset($SessionPost["ViewState"]["ErrorsArray"]);
                        modApiFunc("Payment_Module_Moneybooewallet_CC", "saveValidatedSW", $merchantSW);
                    }
                    else
                    {
                        if ($result['body'] == 'NOK')
                            $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_COULD_NOT_VALIDATE_SW";
                        if ($result['body'] == 'VELOCITY_CHECK_EXCEEDED')
                            $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_VELOCITY_CHECK_EXCEEDED";
                        if ($result['body'] == 'REQUESTER_NOT_AUTHORISED')
                            $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_REQUESTER_NOT_AUTHORISED";
                    }
                }
                break;
            }
            case "quickCheckout":
            {
                $settings = modApiFunc('Payment_Module_Moneybooewallet_CC', 'getSettings');

                if ($settings['MODULE_MERCHANT_EMAIL'] == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_MERCHANT_EMAIL";
                }
                if ($settings['MODULE_CUSTOMER_ID'] == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_CUSTOMER_ID";
                }

                $shop_url = '';
                $layouts = LayoutConfigurationManager::static_get_cz_layouts_list();
                foreach ($layouts as $l)
                {
                    $shopUrl = $l['SITE_URL'];
                    break;
                }

                if (sizeof($SessionPost["ViewState"]["ErrorsArray"]) == 0)
                {
                    $from_address = modApiFunc("Configuration", "getValue", "store_owner_site_administrator_email_from");
                    $subject      = getMsg("PM_MBK_CC", "QUICK_CHECKOUT_MAIL_SUBJECT");
                    $body         = getMsg("PM_MBK_CC", "QUICK_CHECKOUT_MAIL_BODY");

                    $dataFields = array
                    (
                        "EMAIL"     => $settings["MODULE_MERCHANT_EMAIL"]
                       ,"CUST_ID"   => $settings["MODULE_CUSTOMER_ID"]
                       ,"SHOP_URL"  => $shopUrl
                       ,"LANG"		=> $settings["MODULE_LANGUAGE"]
                    );

                    $body = strtr($body, $dataFields);

                    loadCoreFile('ascHtmlMimeMail.php');
                    $mail = new ascHtmlMimeMail();
                    $mail->setText($body);
                    $mail->setSubject($subject);
                    $mail->setFrom($from_address);
                    $to = "ecommerce@moneybookers.com";

                    $rlt = $mail->send(array($to));
                    if ($rlt)
                    {
                        $SessionPost["ViewState"]["MailMessage"] = 'MODULE_ACTIVATION_EMAIL_SENT_MESSAGE';
                    }
                    else
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_COULD_NOT_SENT_ACTIVATION_EMAIL";
                    }
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>