<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update NetworkMerchants settings.
 *
 * @package PaymentModuleNetworkMerchantsCC
 * @access  public
 * @author Egor Makarov
 */
class update_network_merchants extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * update_network_merchants constructor.
     */
    function update_network_merchants()
    {
    }


    function saveDataToDB($SessionPost)
    {
        if (!defined('DEMO_MODE'))
        {
            modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Network_Merchants_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);
        }

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                ,"MODULE_USERNAME" => $SessionPost["ModuleUsername"]
                ,"MODULE_PASSWORD" => $SessionPost["ModulePassword"]
//              ,"MODULE_TRANSACTION_TYPE" => $SessionPost["ModuleTransactionType"]
            );

        modApiFunc("Payment_Module_Network_Merchants_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo", "creditCardInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

				if (array_key_exists("ModuleName", $SessionPost) == false ||
				    trim($SessionPost["ModuleName"]) == '')
				{
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
				}

				if ($SessionPost["ModuleMode"] == "2")
				{
					// testing mode parameters are in the initial mode, so
					// check the filling the account with parameters in the
					// production-mode only.
					if (array_key_exists("ModuleUsername", $SessionPost) == false ||
					    trim($SessionPost["ModuleUsername"]) == '')
					{
						$SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_USERNAME";
					}

					if (array_key_exists("ModulePassword", $SessionPost) == false ||
					    trim($SessionPost["ModulePassword"]) == '')
					{
						$SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PASSWORD";
					}
				}

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>