<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * CheckoutPaymentModuleNetworkMerchantsCCOutput view
 *
 * @package PaymentModuleNetworkMerchantsCC
 * @author Egor Makarov
 */
class CheckoutPaymentModuleNetworkMerchantsCCOutput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {
            $format = array(
                'layout-file'        => "checkout-payment-module-network-merchants-cc-output-config.ini" //; $this->LayoutFile
               ,'files' => array(
                    'OutputContainer'               => TEMPLATE_FILE_SIMPLE
                )
               ,'options' => array(
                )
            );
            return $format;
    }

    /**
     *  CheckoutPaymentModuleNetworkMerchantsCCOutput constructor.
     */
    function CheckoutPaymentModuleNetworkMerchantsCCOutput()
    {
        global $application;

        // check if fatal errors exist in the block tag
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }
    }

    /**
     *
     */
    function output()
    {
        global $application;
        $msg = &$application->getInstance("MessageResources");

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        $this->_Template_Contents = array(
                                          "Local_PaymentMethodName" => ""
                                         ,"Local_CreditCardInfoOutput"    => ""
                                         );

        $application->registerAttributes($this->_Template_Contents);
        $retval = $this->templateFiller->fill("OutputContainer");
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
        switch ($tag)
        {
            case 'Local_PaymentMethodName':
                $value = $ModuleInfo['Name'];
                break;

            case 'Local_CreditCardInfoOutput':
                $pm_uuid = call_user_func(array($this->ModuleAPIClassName, "getUid"));
                $value = getCheckoutCreditCardInfoOutput($pm_uuid);
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $ModuleAPIClassName = "Payment_Module_Network_Merchants_CC";
    var $BlockTemplateName = "CheckoutPaymentModuleNetworkMerchantsCCOutput";
    var $LayoutFile = "checkout-payment-module-network-merchants-cc-output-config.ini";
    /**#@-*/

}
?>