<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleNovaCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Nova_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModuleNova  constructor.
     */
    function Payment_Module_Nova_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'NovaErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'NovaErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'NovaErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'NovaErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'NovaErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_NOVA_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_NOVA_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Nova_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");

        $tables = Payment_Module_Nova_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_nova_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_ACCOUNT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_USER_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_PIN", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_PAYMENT_METHOD", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Nova_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Nova UID
//        return "99AFF9BD-F95C-472F-A453-3D6047A1EE13";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "nova_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleNovaCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleNovaCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_nova_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_nova_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_nova_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_nova_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_nova_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_nova_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile("aal.class.php");

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

//        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
//        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $settings = $this->getSettings();
        $testmode = ($settings["MODULE_MODE"] == 1) ? "TRUE" : "FALSE";

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                 $currencyId));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                   $currencyId));
        $shipping    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost",   $currencyId));
        $subtotal    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal",    $currencyId));

        $bfirstname = $billingInfo->getByMask('Firstname');
        $blastname = $billingInfo->getByMask('Lastname');
        $baddress1 = $billingInfo->getByMask('Streetline1');
        $baddress2 = $billingInfo->getByMask('Streetline2');
        $bcity =     $billingInfo->getByMask('City');
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bzip =      $billingInfo->getByMask('Postcode');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');
        $bphone =    $billingInfo->getByMask('Phone');
        $email =     $billingInfo->getByMask('Email');

//        $sfirstname = $shippingInfo->getByMask('Firstname');
//        $slastname = $shippingInfo->getByMask('Lastname');
//        $saddress1 = $shippingInfo->getByMask('Streetline1');
//        $saddress2 = $shippingInfo->getByMask('Streetline2');
//        $scity =     $shippingInfo->getByMask('City');
//        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
//        $szip =      $shippingInfo->getByMask('Postcode');
//        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');
//        $sphone =    $shippingInfo->getByMask('Phone');

        $confirmationData = array
            (
                "FormAction" => "https://www.myvirtualmerchant.com/VirtualMerchant/process.do"//$self_link
                ,"FormMethod" => "POST"
                ,"DataFields" => array(
                     "ssl_test_mode"          => $testmode
                    ,"ssl_merchant_id"        => $settings["MODULE_ACCOUNT_ID"]
                    ,"ssl_user_id"            => $settings["MODULE_USER_ID"]
                    ,"ssl_pin"                => $settings["MODULE_PIN"]
                    ,"ssl_transaction_type"   => "ccsale"
                    ,"ssl_amount"             => $total
                    ,"ssl_invoice_number"     => $orderId
                    ,"ssl_customer_code"      => $email
                    ,"ssl_first_name"         => $bfirstname
                    ,"ssl_last_name"          => $blastname
                    ,"ssl_avs_address"        => $baddress1
                    ,"ssl_address2"           => $baddress2
                    ,"ssl_city"               => $bcity
                    ,"ssl_state"              => $bstate
                    ,"ssl_avs_zip"            => $bzip
                    ,"ssl_phone"              => $bphone
                    ,"ssl_country"            => $bcountry
                    ,"ssl_email"              => $email
//                    ,"ssl_ship_to_first_name" => $sfirstname
//                    ,"ssl_ship_to_last_name"  => $slastname
//                    ,"ssl_ship_to_address1"   => $saddress1
//                    ,"ssl_ship_to_address2"   => $saddress2
//                    ,"ssl_ship_to_city"       => $scity
//                    ,"ssl_ship_to_state"      => $sstate
//                    ,"ssl_ship_to_zip"        => $szip
//                    ,"ssl_ship_to_country"    => $scountry
//                    ,"ssl_ship_to_phone"      => $sphone
                )
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_NOVA_LOG_EVENT_DESCRIPTION') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_NOVA_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["ssl_result"])
        	&& $data["_POST"]["ssl_result"] == '0'
        	&& isset($data["_POST"]["ssl_result_message"])
        	&& _ml_strtoupper($data["_POST"]["ssl_result_message"]) == "APPROVAL") // use "APPROVED" in test mode
       	{
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Nova_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Nova_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /**
     * parses XML tags, seeks for tags given in $fields
     *
     * @param string array $fields
     * @param string $raw
     * @return unknown
     */

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        foreach ($fields as $tag => $val)
        {
            $xml_tag = $xml->document->findChildRecursively($tag);
            if ($xml_tag != FALSE)
            {
                $fields[$tag] = $xml_tag->contents;
            }
        }

        return $fields;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "ssl_card_number" => ""
            ,"ssl_exp_date" => ""
            ,"ssl_amount" => ""
            ,"ssl_result" => ""
            ,"ssl_result_message" => ""
            ,"ssl_txn_id" => ""
            ,"ssl_approval_code" => ""
            ,"ssl_cvv2_response" => ""
            ,"ssl_avs_response" => ""
            ,"ssl_account_balance" => ""
            ,"ssl_txn_time" => ""
            ,"errorCode" => ""
            ,"errorName" => ""
            ,"errorMessage" => ""
        );

        return $this->parseXmlTags($fields, $raw);
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $settings = $this->getSettings();
        $testmode = ($settings["MODULE_MODE"] == 1) ? "TRUE" : "FALSE";

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        // notice: a two-digit year
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";
        $cardExpYear = sprintf("%02d", $cardExpYear);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                 $currencyId));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                   $currencyId));
        $shipping    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost",   $currencyId));
        $subtotal    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal",    $currencyId));

        $bfirstname = $billingInfo->getByMask('Firstname');
        $blastname = $billingInfo->getByMask('Lastname');
        $baddress1 = $billingInfo->getByMask('Streetline1');
        $baddress2 = $billingInfo->getByMask('Streetline2');
        $bcity =     $billingInfo->getByMask('City');
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bzip =      $billingInfo->getByMask('Postcode');
        $bzip =      preg_replace("/[^a-z0-9]/i", "", $bzip);
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');
        $bphone =    $billingInfo->getByMask('Phone');
        $email =     $billingInfo->getByMask('Email');

        $sfirstname = $shippingInfo->getByMask('Firstname');
        $slastname = $shippingInfo->getByMask('Lastname');
        $saddress1 = $shippingInfo->getByMask('Streetline1');
        $saddress2 = $shippingInfo->getByMask('Streetline2');
        $scity =     $shippingInfo->getByMask('City');
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $szip =      $shippingInfo->getByMask('Postcode');
        $szip =      preg_replace("/[^a-z0-9]/i", "", $szip);
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');
        $sphone =    $shippingInfo->getByMask('Phone');

        $fields = array(
                     "TEST_MODE"        => $testmode
                    ,"MERCHANT_ID"      => $settings["MODULE_ACCOUNT_ID"]
                    ,"USER_ID"          => $settings["MODULE_USER_ID"]
                    ,"PIN"              => $settings["MODULE_PIN"]
                    ,"CARD_NUMBER"      => $cardNumber
                    ,"EXP_DATE"         => $cardExpMonth.$cardExpYear
                    ,"TOTAL_AMT"        => $total
                    ,"SALES_TAX"        => $tax
                    ,"CVV"              => $CVM
                    ,"INVOICE_NUMBER"   => "asc"
                    ,"CUSTOMER_CODE"    => _ml_substr($email, 0, 17)
                    ,"BFIRSTNAME"       => _ml_substr($bfirstname, 0, 20)
                    ,"BLASTNAME"        => _ml_substr($blastname, 0, 30)
                    ,"BADDRESS1"        => _ml_substr($baddress1, 0, 20)
                    ,"BADDRESS2"        => _ml_substr($baddress2, 0, 30)
                    ,"BCITY"            => _ml_substr($bcity, 0, 30)
                    ,"BSTATE"           => _ml_substr($bstate, 0, 30)
                    ,"BZIP"             => _ml_substr($bzip, 0, 9)
                    ,"BPHONE"           => _ml_substr($bphone, 0, 20)
                    ,"BCOUNTRY"         => _ml_substr($bcountry, 0, 50)
                    ,"BEMAIL"           => _ml_substr($email, 0, 100)
                    ,"SFIRSTNAME"       => _ml_substr($sfirstname, 0, 20)
                    ,"SLASTNAME"        => _ml_substr($slastname, 0, 30)
                    ,"SADDRESS1"        => _ml_substr($saddress1, 0, 30)
                    ,"SADDRESS2"        => _ml_substr($saddress2, 0, 30)
                    ,"SCITY"            => _ml_substr($scity, 0, 30)
                    ,"SSTATE"           => _ml_substr($sstate, 0, 30)
                    ,"SZIP"             => _ml_substr($szip, 0, 10)
                    ,"SCOUNTRY"         => _ml_substr($scountry, 0, 50)
                    ,"SPHONE"           => _ml_substr($sphone, 0, 20)
            );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_content = array("xmldata" => strtr($xml_content, $fields));

    //=========================== logging request ========================

        $fields['CARD_NUMBER'] = preg_replace('/[0-9]/', 'x', $fields['CARD_NUMBER']);
        $fields['CVV'] = preg_replace('/[0-9]/', 'x', $fields['CVV']);
        $fields['EXP_DATE'] = preg_replace('/[0-9]/', 'x', $fields['EXP_DATE']);
        $xml_logged = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_logged = array("xmldata" => strtr($xml_logged, $fields));

        $msgObj = $application->getInstance("MessageResources", "payment-module-nova-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_REQUEST"), prepareArrayDisplay($xml_logged));

    //=========================== logging request ========================

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('GET');
        $bnc->setURL("https://www.myvirtualmerchant.com/VirtualMerchant/processxml.do");
        $bnc->setGETstring($bnc->prepareDATAstring($xml_content));
        $result = $bnc->RunRequest();

    //=========================== logging request ========================

        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_RESPONSE"), prepareArrayDisplay($result));

    //=========================== logging request ========================

        if ($result)
            $arrRlt = $this->parseResponse($result["body"]);
        else
            $arrRlt = false;

        $msgObj = $application->getInstance("MessageResources", "payment-module-nova-messages", "AdminZone");
        if (isset($arrRlt["ssl_result"]) && $arrRlt["ssl_result"] == 0) // APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $arrRlt, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if ($arrRlt == false)
	        {
	            // couldn't reach Nova Gateway,
	            // looks like wrong gateway settings
	            $msg = $msgObj->getMessage("ERROR_NO_RESPONSE");
                $this->setErrorMessage($msg);
	        }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT")
                    .$arrRlt["ssl_result_message"]."<br />";
                if ($arrRlt["errorCode"] != '') $msg .= $arrRlt["errorCode"];
                if ($arrRlt["errorName"] != '') $msg .= "<br />".$arrRlt["errorName"];
                if ($arrRlt["errorMessage"] != '') $msg .= "<br />".$arrRlt["errorMessage"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_nova_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_nova_setting_id'
               ,'key'               => $settings.'.pm_nova_setting_key'
               ,'value'             => $settings.'.pm_nova_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-nova-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_NOVA_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>