<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * @package PaymentModuleOrbitalCC
 * @author Egor V. Derevyankin
 */

class CheckoutPaymentModuleOrbitalCCInputAZ extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor
     */
    function CheckoutPaymentModuleOrbitalCCInputAZ()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-orbital-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     *                         POST
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    /**
     *                         DB
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_Orbital_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME": $this->POST["MODULE_NAME"] = $value; break;
                case "MODULE_MODE" : $this->POST["MODULE_MODE"] = $value; break;
                case "ORBITAL_MERCHANT_ID" : $this->POST["ORBITAL_MERCHANT_ID"] = $value;break;
                case "ORBITAL_BIN" : $this->POST["ORBITAL_BIN"] = $value;break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_Orbital_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     *
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_orbital/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     *
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_orbital/", "status.tpl.html", array());
        return $retval;
    }

    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_orbital");
        $form_action = $request->getURL();

        $mode_select = array(
            "select_name" => "MODULE_MODE"
           ,"selected_value" => $this->POST["MODULE_MODE"]
           ,"values" => array(
                array("value" => ORBITAL_MODE_PRODUCTION, "contents" => getMsg('ORBITAL','MODE_PRODUCTION'))
               ,array("value" => ORBITAL_MODE_TEST, "contents" => getMsg('ORBITAL','MODE_TEST'))
           )
        );

        $bin_select = array(
            "select_name" => "ORBITAL_BIN"
           ,"selected_value" => $this->POST["ORBITAL_BIN"]
           ,"values" => array(
                array("value" => ORBITAL_BIN_SALEM, "contents" => ORBITAL_BIN_SALEM . ' - ' . getMsg('ORBITAL','BIN_SALEM'))
               ,array("value" => ORBITAL_BIN_TAMPA, "contents" => ORBITAL_BIN_TAMPA . ' - ' . getMsg('ORBITAL','BIN_TAMPA'))
           )
        );

        $template_contents = array(
                                    "EditOrbitalForm"        => $HtmlForm1->genForm($form_action, "POST", "EditOrbitalForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()

                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-orbital-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleMethodNameFieldName"   => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-orbital-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "MODULE_NAME", "75", prepareHTMLDisplay($this->POST["MODULE_NAME"]))

                                   ,"ModuleModeFieldName"    => $this->MessageResources->getMessage('MODULE_MODE_FIELD_NAME')
                                   ,"ModuleModeSelect"       => $HtmlForm1->genDropdownSingleChoice($mode_select)

                                   ,"ModuleUsernameFieldName"   => $this->MessageResources->getMessage('MODULE_USERNAME_FIELD_NAME')
                                   ,"ModuleUsernameFieldHint"   => $this->Hints->getHintLink(array('MODULE_USERNAME_FIELD_NAME', 'payment-module-orbital-messages'))
                                   ,"ModuleUsernameField"       => $HtmlForm1->genInputTextField("128", "ORBITAL_MERCHANT_ID", "75", prepareHTMLDisplay($this->POST["ORBITAL_MERCHANT_ID"]))

                                   ,"ModuleBinFieldName" => $this->MessageResources->getMessage('MODULE_BIN_FIELD_NAME')
                                   ,"ModuleBinFieldHint" => $this->Hints->getHintLink(array('MODULE_BIN_FIELD_NAME', 'payment-module-orbital-messages'))
                                   ,"ModuleBinSelect"    => $HtmlForm1->genDropdownSingleChoice($bin_select)

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()
                                   );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_orbital/", "list.tpl.html", array());
    }

    /**
     *                      ,                        $tag
     */
    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
                $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. Comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. Comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>