<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for updating PayPal settings.
 *
 * @package PaymentModulePaypalPro CC
 * @access  public
 * @author Alexander Girin
 */
class update_paypalpro extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_paypalpro()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_PaypalPro_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
                         ,"EXPRESS_CHECKOUT_METHOD_NAME" => $SessionPost["ExpressCheckoutMethodName"]
                         ,"DIRECT_PAYMENT_METHOD_NAME" => $SessionPost["DirectPaymentMethodName"]
                         ,"MODULE_API_USERNAME" => $SessionPost["ModuleApiUsername"]
                         ,"MODULE_API_PASSWORD" => $SessionPost["ModuleApiPassword"]
                         ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                         ,"MODULE_CART" => $SessionPost["ModuleCart"]
                         ,"MODULE_LOGO" => $SessionPost["ModuleLogo"]
                         ,"MODULE_API_SIGNATURE" => $SessionPost["ModuleApiSignature"]
                         );
        if (isset($SessionPost["ModuleApiCertificate"]))
        {
            $Settings["MODULE_API_CERTIFICATE"] = $SessionPost["ModuleApiCertificate"];
        }

        modApiFunc("Payment_Module_PaypalPro_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo", "creditCardInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (empty($SessionPost["ExpressCheckoutMethodName"]) == true || trim($SessionPost["ExpressCheckoutMethodName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_EXPRESS_NAME";
                }
                if (empty($SessionPost["DirectPaymentMethodName"]) == true || trim($SessionPost["DirectPaymentMethodName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_DIRECT_NAME";
                }
                if (empty($SessionPost["ModuleApiUsername"]) == true || trim($SessionPost["ModuleApiUsername"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_USERNAME";
                }
                if (empty($SessionPost["ModuleApiPassword"]) == true || trim($SessionPost["ModuleApiPassword"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PASSWORD";
                }

                if ($SessionPost["AuthenticationType"] == "signature")
                {
                    $SessionPost["ModuleApiSignature"] = trim($SessionPost["ModuleApiSignature"]);
                    if (empty($SessionPost["ModuleApiSignature"]))
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_API_SIGNATURE_ERROR';
                    }
                }
                else
                {
                    $SessionPost["ModuleApiSignature"] = "";
                }

                if ($SessionPost["AuthenticationType"] == "certificate" && array_key_exists("ModuleApiCertificate",$_FILES) && $_FILES["ModuleApiCertificate"]['tmp_name'])
                {
                    if ($_FILES["ModuleApiCertificate"]['size'] > 0 && filesize($_FILES["ModuleApiCertificate"]['tmp_name']) != FALSE)
                    {
                            $file_name = $application->getAppIni('PATH_MODULES_DIR')."payment_module_paypalpro_cc/APICertificate/".$_FILES["ModuleApiCertificate"]["name"];
                            @chmod(dirname($file_name), 0777);
                            if (@move_uploaded_file($_FILES["ModuleApiCertificate"]['tmp_name'], $file_name))
                            {
                                @chmod($file_name, 0644);
                                $SessionPost["ModuleApiCertificate"] = $file_name;
                            }
                            else
                            {
                                $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_API_CERTIFICATE_ERROR';
                            }
                            @chmod(dirname($file_name), 0755);
                    }
                    else
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = 'MODULE_API_CERTIFICATE_ERROR';
                    }
                }

                if (empty($SessionPost["ModuleLogo"]) != true)
                {
                    // validate url
                    loadCoreFile("URI.class.php");
                    $url = new URI($SessionPost["ModuleLogo"]);
                    if ($url == NULL)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_IMG_URL";
                    }
                    else
                    {
                        if ($url->getPart("host") == NULL ||
                            $url->getPart("path") == NULL ||
                            $url->getPart("query") != NULL ||
                            $url->getPart("user") != NULL ||
                            $url->getPart("pass") != NULL ||
                            preg_match("/.\.(gif|jpg|jpeg|png|bmp)$/i", $url->getPart("path")) == NULL)
                        {
                            $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_IMG_URL";
                        }
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        $Settings = modApiFunc("Payment_Module_PaypalPro_CC", "getSettings");
        if (!$Settings['MODULE_BILLING_PERSON_INFO_VARIANT'])
        {
            modApiFunc("Payment_Module_PaypalPro_CC", "updateSettings", array("MODULE_BILLING_PERSON_INFO_VARIANT" => modApiFunc("Payment_Module_PaypalPro_CC", "setPersonInfoVariant", "billingInfo", "ExpressCheckout")));
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>