<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * paypalpro_cc_input_az view.
 *
 * @package PaymentModulePaypalPro CC
 * @author Alexander Girin
 */
class paypalpro_cc_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *
     */
    function paypalpro_cc_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     *Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
        $this->POST["status"] = ($this->POST["status"] == "active") ? true : false;
        if (!isset($this->POST["ModuleApiCertificate"]))
        {
            $settings = modApiFunc("Payment_Module_PaypalPro_CC", "getSettings");
            $this->POST["ModuleApiCertificate"] = $settings["MODULE_API_CERTIFICATE"];
        }
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_PaypalPro_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":                  $this->POST["ModuleName"] = $value; break;
                case "EXPRESS_CHECKOUT_METHOD_NAME": $this->POST["ExpressCheckoutMethodName"] = $value; break;
                case "DIRECT_PAYMENT_METHOD_NAME":   $this->POST["DirectPaymentMethodName"] = $value; break;
//                case "MODULE_DESCR":                 $this->POST["ModuleDescr"] = $value; break;
                case "MODULE_API_CERTIFICATE":       $this->POST["ModuleApiCertificate"] = $value; break;
                case "MODULE_API_SIGNATURE":         $this->POST["ModuleApiSignature"] = $value; break;
                case "MODULE_API_USERNAME":          $this->POST["ModuleApiUsername"] = $value; break;
                case "MODULE_API_PASSWORD":          $this->POST["ModuleApiPassword"] = $value; break;
                case "MODULE_MODE" :                 $this->POST["ModuleMode"] = $value; break;
                case "MODULE_CART" :                 $this->POST["ModuleCart"] = $value; break;
                case "MODULE_LOGO" :                 $this->POST["ModuleLogo"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_PaypalPro_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_paypalpro/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_paypalpro/", "status.tpl.html", array());
        return $retval;
    }

    function outputModeOptions()
    {
        $retval = "";
        $options = array(array("value" => "1", "text" => $this->MessageResources->getMessage('MODE_001')), array("value" => "2", "text" => $this->MessageResources->getMessage('MODE_002')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleMode"]? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    function outputCartOptions()
    {
        $retval = "";
        $options = array(array("value" => "1", "text" => $this->MessageResources->getMessage('YES_LABEL')), array("value" => "2", "text" => $this->MessageResources->getMessage('NO_LABEL')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleCart"]? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_paypalpro");
        $form_action = $request->getURL();

        $template_contents = array(
                                    "EditPayPalForm"        => $HtmlForm1->genForm($form_action, "POST", "EditPayPalForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_NAME_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "60", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"Method1NameFieldName"  => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME_001')
                                   ,"Method1NameFieldHint"  => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME_001', 'payment-module-paypalpro-messages'))
                                   ,"Method1NameField"      => $HtmlForm1->genInputTextField("128", "ExpressCheckoutMethodName", "60", prepareHTMLDisplay($this->POST["ExpressCheckoutMethodName"]))

                                   ,"Method2NameFieldName"  => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME_002')
                                   ,"Method2NameFieldHint"  => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME_002', 'payment-module-paypalpro-messages'))
                                   ,"Method2NameField"      => $HtmlForm1->genInputTextField("128", "DirectPaymentMethodName", "60", prepareHTMLDisplay($this->POST["DirectPaymentMethodName"]))

//                                   ,"ModuleMethodNameFieldName"   => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
//                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-paypalpro-messages'))
//                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
//                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
//                                   ,"ModuleDescrFieldHint"  => $this->Hints->getHintLink(array('MODULE_DESCR_FIELD_NAME', 'payment-module-paypalpro-messages'))
//                                   ,"ModuleDescrField"      => $HtmlForm1->genInputTextAreaField("75", "ModuleDescr", "5")
//                                   ,"ModuleDescrFieldValue" => $this->POST["ModuleDescr"]

                                   ,"ModuleApiCertificateField"      => $HtmlForm1->genInputFileName("ModuleApiCertificate", "57")
                                   ,"ModuleApiCertificateValue"      => prepareHTMLDisplay(basename($this->POST["ModuleApiCertificate"]))
                                   ,"ModuleApiCertificateFieldParams"=> ($this->POST["ModuleApiCertificate"]? "disabled style='display: none;'": "")
                                   ,"ModuleApiCertificateChangeParams"=> ($this->POST["ModuleApiCertificate"]? "":"style='display: none;'")
                                   ,"ModuleAPICertificateChange"     => $this->MessageResources->getMessage('MODULE_API_CERTIFICATE_CHANGE')
                                   ,"ModuleAPICertificateCancel"     => $this->MessageResources->getMessage('MODULE_API_CERTIFICATE_CANCEL')

                                   ,"ModuleApiAuthenticationFieldName"  => $this->MessageResources->getMessage('MODULE_API_AUTHENTICATION_FIELD_NAME')
                                   ,"ModuleApiAuthenticationFieldHint"  => $this->Hints->getHintLink(array('MODULE_API_AUTHENTICATION_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleApiSignatureField" => $HtmlForm1->genInputTextField("128", "ModuleApiSignature", "60", prepareHTMLDisplay($this->POST["ModuleApiSignature"]))

                                   ,"CertificateChecked"     => modApiFunc('Payment_Module_PaypalPro_CC', 'usesSignature') ? '' : 'checked="checked"'
                                   ,"SignatureChecked"     => modApiFunc('Payment_Module_PaypalPro_CC', 'usesSignature') ? 'checked="checked"' : ''


                                   ,"ModuleApiUsernameFieldName"  => $this->MessageResources->getMessage('MODULE_API_USERNAME_FIELD_NAME')
                                   ,"ModuleApiUsernameFieldHint"  => $this->Hints->getHintLink(array('MODULE_API_USERNAME_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleApiUsernameField"      => $HtmlForm1->genInputTextField("128", "ModuleApiUsername", "35", prepareHTMLDisplay($this->POST["ModuleApiUsername"]))
                                   ,"ModuleApiPasswordFieldName"  => $this->MessageResources->getMessage('MODULE_API_PASSWORD_FIELD_NAME')
                                   ,"ModuleApiPasswordFieldHint"  => $this->Hints->getHintLink(array('MODULE_API_PASSWORD_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleApiPasswordField"      => $HtmlForm1->genInputTextField("128", "ModuleApiPassword", "35", prepareHTMLDisplay($this->POST["ModuleApiPassword"]))
                                   ,"ModuleCartFieldName"    => $this->MessageResources->getMessage('MODULE_CART_FIELD_NAME')
                                   ,"ModuleCartFieldHint"    => $this->Hints->getHintLink(array('MODULE_CART_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleCartOptions"      => $this->outputCartOptions()
                                   ,"ModuleModeFieldName"    => $this->MessageResources->getMessage('MODULE_MODE_FIELD_NAME')
                                   ,"ModuleModeFieldHint"    => $this->Hints->getHintLink(array('MODULE_MODE_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleModeOptions"      => $this->outputModeOptions()
                                   ,"ModuleLogoFieldName"    => $this->MessageResources->getMessage('MODULE_LOGO_FIELD_NAME')
                                   ,"ModuleLogoFieldHint"    => $this->Hints->getHintLink(array('MODULE_LOGO_FIELD_NAME', 'payment-module-paypalpro-messages'))
                                   ,"ModuleLogoField"        => $HtmlForm1->genInputTextField("255", "ModuleLogo", "60", prepareHTMLDisplay($this->POST["ModuleLogo"]))
                                   ,"ModuleLogoSrc"          => $this->POST["ModuleLogo"]
                                   ,"Alert_001"              => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"              => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"              => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"              => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"              => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"              => $this->MessageResources->getMessage('ALERT_006')
                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()
                                   );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_paypalpro/", "list.tpl.html",array());
    }

    function getTag($tag)
    {
        global $application;
        switch ($tag)
        {
            case "Error":
                $value = $this->_error;
                break;
            case "ErrorIndex":
                $value = $this->_error_index;
                break;
            default:
                $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
                break;
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>