<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModulePaypalPro_UK_CC
 * @author Ravil Garafutdinov
 */
class Payment_Module_PaypalPro_UK_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModulePaypalPro_UK constructor.
     */
    function Payment_Module_PaypalPro_UK_CC()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");

        $info = $this->getInfo();

        $this->getSettings();

        $this->paymentMethod = "";

        $this->ExpessCheckoutData = array();

        $this->CCInfo = array();

        $this->response = array();

        $this->OrderHistoryMessageTag = $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" . $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
               array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * Restores the module state from the session.
     */
    function loadState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if(modApiFunc('Session', 'is_Set', 'PaypalPro_UK_response'))
            {
                $this->response = modApiFunc('Session', 'get', 'PaypalPro_UK_response');
            }
            if(modApiFunc('Session', 'is_Set', 'PaypalPro_UK_paymentMethod'))
            {
                $this->paymentMethod = modApiFunc('Session', 'get', 'PaypalPro_UK_paymentMethod');
            }
            if(modApiFunc('Session', 'is_Set', 'PaypalPro_UK_ExpessCheckoutData'))
            {
                $this->ExpessCheckoutData = modApiFunc('Session', 'get', 'PaypalPro_UK_ExpessCheckoutData');
            }
        }

        if(modApiFunc('Session', 'is_Set', 'PaypalProUKErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'PaypalProUKErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    /**
     * Saves the module state.
     */
    function saveState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if (sizeof($this->response))
            {
                modApiFunc('Session', 'set', 'PaypalPro_UK_response', $this->response);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PaypalPro_UK_response'))
            {
                modApiFunc('Session', 'un_Set', 'PaypalPro_UK_response');
            }

            if ($this->paymentMethod)
            {
                modApiFunc('Session', 'set', 'PaypalPro_UK_paymentMethod', $this->paymentMethod);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PaypalPro_UK_paymentMethod'))
            {
                modApiFunc('Session', 'un_Set', 'PaypalPro_UK_paymentMethod');
            }

            if (sizeof($this->ExpessCheckoutData))
            {
                modApiFunc('Session', 'set', 'PaypalPro_UK_ExpessCheckoutData', $this->ExpessCheckoutData);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PaypalPro_UK_ExpessCheckoutData'))
            {
                modApiFunc('Session', 'un_Set', 'PaypalPro_UK_ExpessCheckoutData');
            }
        }

        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'PaypalProUKErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'PaypalProUKErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'PaypalProUKErrorMessage');
        }
    }

    function set3dsValues($key, $value)
    {
        $current = $this->get3dsValues();
        $current[$key] = $value;
        modApiFunc('Session', 'set', 'PaypalProUK3dsValues', $current);
    }

    function get3dsValues()
    {
        if (modApiFunc('Session', 'is_Set', 'PaypalProUK3dsValues'))
        {
            return modApiFunc('Session', 'get', 'PaypalProUK3dsValues');
        }
        return array();
    }

    function unset3dsValues()
    {
        if (modApiFunc('Session', 'is_Set', 'PaypalProUK3dsValues'))
        {
            modApiFunc('Session', 'un_Set', 'PaypalProUK3dsValues');
        }
    }

    function gettime()
    {
        return $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_EVENT_TIME') . modApiFunc("Localization", "timestamp_date_format", time())." ". modApiFunc("Localization", "timestamp_time_format", time());
    }

    function setPaymentMethod($method)
    {
        $this->paymentMethod = $method;
    }

    function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    function setExpessCheckoutData($field, $value)
    {
        $this->ExpessCheckoutData[$field] = $value;
    }

    function getExpessCheckoutData($field = "")
    {
        if ($field && isset($this->ExpessCheckoutData[$field]))
        {
            return $this->ExpessCheckoutData[$field];
        }
        else
        {
            return $this->ExpessCheckoutData;
        }
    }

    function clearPaypalPro_UKSession()
    {
        $this->paymentMethod = "";
        $this->ExpessCheckoutData = array();
        $this->response = array();
        $this->SaveState();
    }

    function clearResponseErrors()
    {
        if (isset($this->response["Errors"]["ErrorCode"]))
        {
            $this->response["Errors"]["ErrorCode"] = "";
        }
        if (isset($this->response["Errors"]["ShortMessage"]))
        {
            $this->response["Errors"]["ShortMessage"] = "";
        }
        if (isset($this->response["Errors"]["LongMessage"]))
        {
            $this->response["Errors"]["LongMessage"] = "";
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");

        $tables = Payment_Module_PaypalPro_UK_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_paypalpro_uk_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("EXPRESS_CHECKOUT_METHOD_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('EXPRESS_CHECKOUT_METHOD_NAME')).':"'.$obj->getMessage('EXPRESS_CHECKOUT_METHOD_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("DIRECT_PAYMENT_METHOD_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('DIRECT_PAYMENT_METHOD_NAME')).':"'.$obj->getMessage('DIRECT_PAYMENT_METHOD_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("USERNAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('USERNAME')).':"'.$obj->getMessage('USERNAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("PASSWORD", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('PASSWORD')).':"'.$obj->getMessage('PASSWORD').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("PARTNER", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('PARTNER')).':"'.$obj->getMessage('PARTNER').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_CART", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("ECHECKOUT_URL_TEST", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('ECHECKOUT_URL_TEST')).':"'.$obj->getMessage('ECHECKOUT_URL_TEST').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(10, $columns['id']);
        $query->addInsertValue("ECHECKOUT_URL_LIVE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('ECHECKOUT_URL_LIVE')).':"'.$obj->getMessage('ECHECKOUT_URL_LIVE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(11, $columns['id']);
        $query->addInsertValue("GATEWAY_URL_TEST", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL_TEST')).':"'.$obj->getMessage('GATEWAY_URL_TEST').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(12, $columns['id']);
        $query->addInsertValue("GATEWAY_URL_LIVE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL_LIVE')).':"'.$obj->getMessage('GATEWAY_URL_LIVE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(13, $columns['id']);
        $query->addInsertValue("MODULE_LOGO", $columns['key']);
        $s = "https://www.paypal.com/en_US/i/btn/btn_xpressCheckout.gif";
        $query->addInsertValue('s:'._ml_strlen($s).':"'.$s.'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(14, $columns['id']);
        $query->addInsertValue("MERCHANT_DESCRIPTION", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MERCHANT_DESCRIPTION')).':"'.$obj->getMessage('MERCHANT_DESCRIPTION').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(15, $columns['id']);
        $query->addInsertValue("MODULE_BILLING_PERSON_INFO_VARIANT", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

    // 3D-Secure
        $query = new DB_Insert($table);
        $query->addInsertValue(16, $columns['id']);
        $query->addInsertValue("MODULE_3DS_ENABLE", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(17, $columns['id']);
        $query->addInsertValue("MODULE_3DS_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_3DS_URL_DEFAULT')).':"'.$obj->getMessage('MODULE_3DS_URL_DEFAULT').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(18, $columns['id']);
        $query->addInsertValue("MODULE_3DS_PROCESSOR_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(19, $columns['id']);
        $query->addInsertValue("MODULE_3DS_MERCHANT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(20, $columns['id']);
        $query->addInsertValue("MODULE_3DS_TRANSACTION_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        // VENDOR
        $query = new DB_Insert($table);
        $query->addInsertValue(21, $columns['id']);
        $query->addInsertValue("VENDOR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('VENDOR')).':"'.$obj->getMessage('VENDOR').'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_PaypalPro_UK_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        PaypalPro_UK                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // PaypalPro_UK GUID
//        return "C92C5FAF-D946-453A-A72C-FEEEE54F417D";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");

        $this->getSettings();

        global $zone;
        if ($zone == 'CustomerZone')
        {
            if ($this->paymentMethod == "ExpressCheckout")
            {
                $name = $this->Settings["EXPRESS_CHECKOUT_METHOD_NAME"];
            }
            else
            {
                $name = $this->Settings["DIRECT_PAYMENT_METHOD_NAME"];
            }
        }
        else
        {
            $name = $this->Settings["MODULE_NAME"];
        }

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $name,
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "paypalpro_uk_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModulePaypalProUKCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModulePaypalProUKCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_paypalpro_uk_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settins array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_paypalpro_uk_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_paypalpro_uk_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_paypalpro_uk_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_paypalpro_uk_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_paypalpro_uk_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.00 : number_format($price, 2, '.', '');
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     */
    function getPaymentMode()
    {
        return "direct";
    }

    function getConfirmationData($order_id)
    {
        print "ERROR! getConfirmationData call!";die;
    }

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        //           -                     PersonInfo Variant'    -         /        ...
        if($prerequisite_type == "creditCardInfo")
        {
            //                   'PaypalPro_UK_paymentMethod' = "ExpressCheckout"                           Checkout,
            //  . .                                  (step_id = 2)
            if(modApiFunc('Session', 'is_Set', 'PaypalPro_UK_paymentMethod') && modApiFunc('Session', 'get', 'PaypalPro_UK_paymentMethod') == "ExpressCheckout")
            {
                return false;
            }
            return "default";
        }
        else
        {
            return false;
        }
    }

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        $fields["XMLPayResponse"] = $xml->document->attributes;

        foreach ($fields as $tag => $val)
        {
            if (is_array($tag))
            {
                foreach ($fields[$tag] as $_tag => $_val)
                {
                    $xml_tag = $xml->document->findChildRecursively($_tag);
                    if ($xml_tag != FALSE)
                    {
                        if ($xml_tag->contents != "")
                            $fields[$tag][$_tag] = $xml_tag->contents;
                        else if ($xml_tag->attributes != "")
                            $fields[$tag][$_tag] = $xml_tag->attributes;
                     }
                }
                $xml_tag = $xml->document->findChildRecursively($tag);
            }
            else
            {
                $xml_tag = $xml->document->findChildRecursively($tag);
                if ($xml_tag != FALSE)
                {
                    if ($xml_tag->contents != "")
                        $fields[$tag] = $xml_tag->contents;
                    else if ($xml_tag->attributes != "")
                        $fields[$tag] = $xml_tag->attributes;
                }
            }
        }

        return $fields;
    }

    function getCartItems()
    {
        $settings = $this->getSettings();
        if ($settings["MODULE_CART"] != 1)
            return "";

        $i=1;
        $retval = "";
        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $cart = modApiFunc("Cart", "getCartContent", $currency_id);
        $item_tpl = file_get_contents(dirname(__FILE__)."/includes/itemsPartialRequest.xml");

        foreach ($cart as $item)
        {
            $fields = array (
                 "ITEM_NUMBER"  => $i
                ,"ITEM_SKU"		=> $item["SKU"]
                ,"ITEM_DESCR"	=> $item["Name"]
                ,"ITEM_QUANT"	=> $item["Quantity_In_Cart"]
                ,"ITEM_PRICE"	=> $item["Total"]
            );

            $i++;
            $item = $item_tpl;
            $item = strtr($item, $fields);
            $retval .= $item."\n";
        }
        $retval = "<Items>\n$retval                            </Items>";

        return $retval;
    }

    function doDirectPaymentRequest()
    {
        global $application;
        loadCoreFile('aal.class.php');
        loadCoreFile('bouncer.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $settings = $this->getSettings();
        $cardInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $comment = "";
        if ($billingInfo->getByMask('CommentLine') != "")
            $comment .= $billingInfo->getByMask('CommentLine');
        if ($billingInfo->getByMask('CommentArea') != "")
            $comment .= " ".$billingInfo->getByMask('CommentArea');
        if ($shippingInfo->getByMask('CommentLine') != "")
            $comment .= " ".$shippingInfo->getByMask('CommentLine');
        if ($shippingInfo->getByMask('CommentArea') != "")
            $comment .= " ".$shippingInfo->getByMask('CommentArea');
        $comment = trim($comment);

        $request_id = date("YmdHis").intval(microtime()*1000000);

        $currencyId   = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        $total        = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));

        $maestro_block = '';
        $current_3ds_values = $this->get3dsValues();
        if ($settings['MODULE_3DS_ENABLE'] == '1')
        {
            $fields_3ds = array(
                     'AUTHSTATUS3DS_VALUE' => isset($current_3ds_values['PAResStatus']) ? $current_3ds_values['PAResStatus'] : ''
                    ,'MPIVENDOR3DS_VALUE'  => isset($current_3ds_values['Enrolled'])    ? $current_3ds_values['Enrolled']    : ''
                    ,'ECI3DS_VALUE'        => isset($current_3ds_values['EciFlag'])     ? $current_3ds_values['EciFlag']     : ''
                    ,'CAVV_VALUE'          => isset($current_3ds_values['Cavv'])        ? $current_3ds_values['Cavv']        : ''
                    ,'XID_VALUE'           => isset($current_3ds_values['Xid'])         ? $current_3ds_values['Xid']         : ''
            );

            $xml_content = file_get_contents(dirname(__FILE__)."/includes/3dsRequest.xml");
            $maestro_block = strtr($xml_content, $fields_3ds);
        }

        $dataFields = array
            (
                "VENDOR"               => $settings["VENDOR"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"REQUEST_ID"           => $request_id
               ,"CUSTIP"               => $_SERVER['REMOTE_ADDR']
               ,"MERCHANTDESCRIPTION"  => $settings["MERCHANT_DESCRIPTION"]
               ,"BNAME"                => $billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname")
               ,"BSTREET"              => $billingInfo->getByMask("Streetline1")." ".$billingInfo->getByMask("Streetline2")
               ,"BCITY"                => $billingInfo->getByMask("City")
               ,"BSTATE"               => ($billingInfo->getByMask('Statemenu')) ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext')
               ,"BZIP"                 => $billingInfo->getByMask('Postcode')
               ,"BCOUNTRY"             => $billingInfo->getByMask('Country')//($billingInfo->getByMask('Country')) ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : ""
               ,"BEMAIL"               => $billingInfo->getByMask("Email")
               ,"BPHONE"               => $billingInfo->getByMask("Phone")
               ,"SNAME"                => $shippingInfo->getByMask("Firstname")." ".str_replace("&", "%amp;", $shippingInfo->getByMask("Lastname"))
               ,"SSTREET"              => $shippingInfo->getByMask("Streetline1")." ".$shippingInfo->getByMask("Streetline2")
               ,"SCITY"                => $shippingInfo->getByMask('City')
               ,"SSTATE"               => ($shippingInfo->getByMask('Statemenu')) ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext')
               ,"SZIP"                 => $shippingInfo->getByMask('Postcode')
               ,"SCOUNTRY"             => ($shippingInfo->getByMask('Country')) ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : ""
               ,"SEMAIL"               => $shippingInfo->getByMask("Email")
               ,"SPHONE"               => $shippingInfo->getByMask("Phone")
               ,"<ITEMS/>"			   => $this->getCartItems()
               ,"CURRENCY_CODE"        => $currencyCode
               ,"TOTALAMT"             => $total
               ,"COMMENT"              => $comment
               ,"CARDNUM"              => (isset($cardInfo["CreditCardNumber"]["value"])) ? $cardInfo["CreditCardNumber"]["value"] : ''
               ,"CARDSTART"            => (isset($cardInfo["ValidFromMonth"]["value"]) && isset($cardInfo["ValidFromYear"]["value"])) ? $cardInfo["ValidFromMonth"]["value"] . substr($cardInfo["ValidFromYear"]["value"], 2 ) : ''
               ,"CARDISSUE"            => (isset($cardInfo["CreditCardIssueNumber"]["value"])) ? $cardInfo["CreditCardIssueNumber"]["value"] : ''
               ,"EXPDATE"              => (isset($cardInfo["ExpirationYear"]["value"]) && isset($cardInfo["ExpirationMonth"]["value"])) ? $cardInfo["ExpirationYear"]["value"].$cardInfo["ExpirationMonth"]["value"] : ''
               ,"CVNUM"                => (isset($cardInfo["CreditCardVerificationNumber"]["value"])) ? $cardInfo["CreditCardVerificationNumber"]["value"] : ''
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]

               ,'<Maestro/>'           => $maestro_block
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/directPaymentRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $dataFields["CARDNUM"] = preg_replace("/[0-9]/", 'X', $dataFields["CARDNUM"]);
        $dataFields["CARDSTART"] = preg_replace("/[0-9]/", 'X', $dataFields["CARDSTART"]);
        $dataFields["CARDISSUE"] = preg_replace("/[0-9]/", 'X', $dataFields["CARDISSUE"]);
        $dataFields["EXPDATE"] = preg_replace("/[0-9]/", 'X', $dataFields["EXPDATE"]);
        $dataFields["CVNUM"] = preg_replace("/[0-9]/", 'X', $dataFields["CVNUM"]);

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/directPaymentRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_DIRPM_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the txn was successful, but it's response was lost,
        // the next identical request will have the same response
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //================================ logging ===============================

                $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_DIRPM_RESPONSE"), prepareArrayDisplay($result));

            //================================ logging ===============================
                $this->response = $this->parseResponse($result["body"]);
                return $result["body"];
            }
        }
        return false;
    }

    function getStatusRequest($pnref)
    {
        if (!$pnref)
            return false;

        global $application;
        loadCoreFile('bouncer.php');

        $settings = $this->getSettings();
        $request_id = date("YmdHis").intval(microtime()*1000000);
        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $dataFields = array
            (
                "VENDOR"               => $settings["VENDOR"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"REQUEST_ID"           => $request_id
               ,"PNREF"				   => $pnref
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/getStatusRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/getStatusRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_STATUS_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the trx was successful, but it's responce was lost,
        // the next identical request will have the same responce
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //================================ logging ===============================

                $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_STATUS_RESPONSE"), prepareArrayDisplay($result));

            //================================ logging ===============================
                return $this->parseResponse($result["body"]);
            }
        }
        return false;
    }

    function setExpressCheckoutRequest()
    {
        global $application;
        loadCoreFile('aal.class.php');
        loadCoreFile('bouncer.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $settings = $this->getSettings();
        $request_id = date("YmdHis").intval(microtime()*1000000);
        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        //$total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalToPay", $currencyId));

        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("SetCurrStep");
        $returnUrl = str_replace('&', '&amp;', $request->getURL());

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $cancelUrl = str_replace('&', '&amp;', $request->getURL());

        $dataFields = array
            (
                "REQUEST_ID"           => $request_id
               ,"VENDOR"               => $settings["VENDOR"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"SCOUNTRY"             => $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : ""
               ,"SSTREET"              => $shippingInfo->getByMask("Streetline1")
               ,"SCITY"                => $shippingInfo->getByMask("City")
               ,"SSTATE"               => $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext')
               ,"SZIP"                 => $shippingInfo->getByMask("Postcode")
               ,"<ITEMS/>"			   => $this->getCartItems()
               ,"CURRENCY_CODE"        => $currencyCode
               ,"TOTALAMT"             => $total
               ,"BNAME"                => trim($billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname"))
               ,"BEMAIL"               => ($billingInfo->getByMask("Email")) ? $billingInfo->getByMask("Email") : ""
               ,"CUSTOMER_IP"          => $_SERVER['REMOTE_ADDR']
               ,"RETURN_URL"           => $returnUrl
               ,"CANCEL_URL"           => $cancelUrl
               ,"EMAIL"                => ($billingInfo->getByMask("Email")) ? $billingInfo->getByMask("Email") : ""
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/setExpressCheckout.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/setExpressCheckout.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_SETUP_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the trx was successful, but it's responce was lost,
        // the next identical request will have the same responce
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //================================ logging ===============================

                $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_SETUP_RESPONSE"), prepareArrayDisplay($result));

            //================================ logging ===============================
                $this->response = $this->parseResponse($result["body"]);
                return $this->response;
            }
        }
        return false;
    }

    function getExpressCheckoutDetailsRequest($token = "")
    {
        global $application;

        if ($token == "")
            return false;

        loadCoreFile('bouncer.php');

        $settings = $this->getSettings();
        $request_id = date("YmdHis").intval(microtime()*1000000);

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("SetCurrStep");
        $returnUrl = $request->getURL();

        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $cancelUrl = $request->getURL();

        $dataFields = array
            (
                "REQUEST_ID"           => $request_id
               ,"VENDOR"               => $settings["VENDOR"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"TOKEN"                => $token
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]
               );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/getExpressCheckoutDetails.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/getExpressCheckoutDetails.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_DETAILS_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the trx was successful, but it's response was lost,
        // the next identical request will have the same response
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //================================ logging ===============================

                $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_DETAILS_RESPONSE"), prepareArrayDisplay($result));

            //================================ logging ===============================
                $this->response = $this->parseResponse($result["body"]);
                return $this->response;
            }
        }
        return false;
    }

    function doExpressCheckoutPaymentRequest()
    {
        global $application;

        loadCoreFile('bouncer.php');

        $settings     = $this->getSettings();
        $request_id   = date("YmdHis").intval(microtime()*1000000);
        $currencyId   = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        //$total        = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));
        $total        = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalToPay", $currencyId));
        $payer_id     = $this->getExpessCheckoutData("PayerID");
        $token        = $this->getExpessCheckoutData("token");

        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $dataFields = array
            (
                "REQUEST_ID"           => $request_id
               ,"VENDOR"               => $settings["VENDOR"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"CURRENCY_CODE"        => $currencyCode
               ,"TOTAL_AMT"			   => $total
               ,"PAYER_ID"			   => $payer_id
               ,"TOKEN"                => $token
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]
            );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/doExpressCheckoutPayment.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/doExpressCheckoutPayment.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_PAYMENT_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the trx was successful, but it's response was lost,
        // the next identical request will have the same response
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //================================ logging ===============================

                $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_EXCH_PAYMENT_RESPONSE"), prepareArrayDisplay($result));

            //================================ logging ===============================
                $this->response = $this->parseResponse($result["body"]);
                return $result["body"];
            }
        }
        return false;
    }

    function do3DSCmpiLookup($ccInfoPost)
    {
        global $application;
        loadCoreFile('aal.class.php');
        loadCoreFile('bouncer.php');

        $settings = $this->getSettings();
        $cardInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        // get info from _POST or _SESSION
		if (isset($ccInfoPost["CreditCardNumber"]) && $ccInfoPost["CreditCardNumber"] != '')
		{
			$cardNumber = $ccInfoPost["CreditCardNumber"];
		}
		else if (isset($cardInfo["CreditCardNumber"]["value"]))
		{
			$cardNumber = $cardInfo["CreditCardNumber"]["value"];
		}

		if (isset($ccInfoPost["ExpirationMonth"]) && $ccInfoPost["ExpirationMonth"] != '')
		{
			$cardExpMonth = $ccInfoPost["ExpirationMonth"];
		}
		else if (isset($cardInfo["ExpirationMonth"]["value"]))
		{
			$cardExpMonth = $cardInfo["ExpirationMonth"]["value"];
		}

		if (isset($ccInfoPost["ExpirationYear"]) && $ccInfoPost["ExpirationYear"] != '')
		{
			$cardExpYear = $ccInfoPost["ExpirationYear"];
		}
		else if (isset($cardInfo["ExpirationYear"]["value"]))
		{
			$cardExpYear = $cardInfo["ExpirationYear"]["value"];
		}


        $request_id  = date("YmdHis").intval(microtime()*1000000);
        $currencyId  = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyIso = modApiFunc("Localization", "getCurrencyIsoById", $currencyId);
        //$total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));
        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalToPay", $currencyId));
        $total = number_format($total * 100, 0, '', '');

        $dataFields = array
            (
                 "MsgType"          => "cmpi_lookup"
                ,"Version"          => "1.7"
                ,"ProcessorId"      => $settings["MODULE_3DS_PROCESSOR_ID"]
                ,"MerchantId"       => $settings["MODULE_3DS_MERCHANT_ID"]
                ,"TransactionPwd"   => $settings["MODULE_3DS_TRANSACTION_PASSWORD"]
                ,"TransactionType"  => "C"
                ,"Amount"           => $total
                ,"CurrencyCode"     => $currencyIso
                ,"CardNumber"       => $cardNumber
                ,"CardExpMonth"     => $cardExpMonth
                ,"CardExpYear"      => $cardExpYear
                ,"OrderNumber"      => $request_id
            );

        $xml_content = $this->get3DSRequestXml($dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_3DS_URL"]);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $dataFields["CardNumber"] = preg_replace("/[0-9]/", 'X', $dataFields["CardNumber"]);
        $dataFields["CardExpMonth"] = preg_replace("/[0-9]/", 'X', $dataFields["CardExpMonth"]);
        $dataFields["CardExpYear"] = preg_replace("/[0-9]/", 'X', $dataFields["CardExpYear"]);

        $xml_content = $this->get3DSRequestXml($dataFields);
        $dataFields['xml_content'] = $xml_content;
        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_LOOKOUT_REQUEST"), prepareArrayDisplay($dataFields));

    //================================ logging ===============================

        $result = $bnc->RunRequest();
        if ($result)
        {
            $this->response = $this->parse3dsResponse($result["body"]);
            $result['parsed'] = $this->response;
        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_LOOKOUT_RESPONSE"), prepareArrayDisplay($result));

        //================================ logging ===============================
            return $this->response;
        }
        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_LOOKOUT_RESPONSE_FAILED"), '');

        //================================ logging ===============================
        return false;
    }

    function do3dsCmpiAuthenticate()
    {
        global $application;
        loadCoreFile('bouncer.php');

        $settings = $this->getSettings();
        $zds_values = $this->get3dsValues();
        $trx_id = (isset($zds_values['trx_id'])) ? $zds_values['trx_id'] : '';
        $PaRes = (isset($zds_values['PaRes'])) ? $zds_values['PaRes'] : '';

        $dataFields = array
            (
                 "MsgType"          => "cmpi_authenticate"
                ,"Version"          => "1.7"
                ,"ProcessorId"      => $settings["MODULE_3DS_PROCESSOR_ID"]
                ,"MerchantId"       => $settings["MODULE_3DS_MERCHANT_ID"]
                ,"TransactionPwd"   => $settings["MODULE_3DS_TRANSACTION_PASSWORD"]
                ,"TransactionType"  => "C"
                ,"TransactionId"    => $trx_id
                ,"PAResPayload"     => $PaRes
            );

        $xml_content = $this->get3DSRequestXml($dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_3DS_URL"]);
        $bnc->setPOSTstring($xml_content);

    //================================ logging ===============================

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_AUTHENTICATE_REQUEST"), prepareArrayDisplay($xml_content));

    //================================ logging ===============================

        $result = $bnc->RunRequest();
        if ($result)
        {
            $this->response = $this->parse3dsResponse($result["body"]);
            $result['parsed'] = $this->response;
        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_AUTHENTICATE_RESPONSE"), prepareArrayDisplay($result));

        //================================ logging ===============================
            return $this->response;
        }
        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_CMPI_AUTHENTICATE_RESPONSE_FAILED"), '');

        //================================ logging ===============================
        return false;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "XMLPayResponse" => false
            ,"TransactionResult" => false
            ,"Vendor" => false
            ,"Partner" => false
            ,"Result" => false
            ,"Message" => false
            ,"PNRef" => false
            ,"Token" => false
            ,"CorrelationID" => false
            ,"EMail" => false
            ,"PayerID" => false
            ,"FeeAmount" => false
            ,"PayerStatus" => false
            ,"Name" => false
            ,"Street" => false
            ,"City" => false
            ,"State" => false
            ,"Zip" => false
            ,"Country" => false
            ,"ExtData" => false
        );

        return $this->parseXmlTags($fields, $raw);
    }

    function parse3dsResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "EciFlag" => false
            ,"Payload" => false
            ,"Enrolled" => false
            ,"TransactionId" => false
            ,"OrderId" => false
            ,"ErrorDesc" => false
            ,"ErrorNo" => false
            ,"ACSUrl" => false
            ,"PAResStatus" => false
            ,"Cavv" => false
            ,"SignatureVerification" => false
            ,"Xid" => false
        );

        return $this->parseXmlTags($fields, $raw);
    }

    function backgroundProcess($type = "doDirectPayment", $transactionData = null)
    {
        global $application;

        $txn = false;
        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro_uk-messages", "AdminZone");
        $settings = $this->getSettings();

    //=======================================================================
    //================================================= Express Checkout ====
        if ($this->paymentMethod == "ExpressCheckout")
        {
            $rawDecpRlt = $this->doExpressCheckoutPaymentRequest();
            $result = $decpRlt = $this->parseResponse($rawDecpRlt);
            $txn = ($result != false && isset($result["Result"])) ? $result["Result"] : false;
            if ($txn == 30) // TIMEOUT
            {
                $gsResult = $this->getStatusRequest($result["PNRef"]);
                if ($gsResult != false)
                {
                    $result = $gsResult;
                    $txn = $result["Result"];
                }
            }
        }
    //=======================================================================
    //================================================= Direct Payment ======
        else // if ($this->paymentMethod == "DirectPayment")
        {
            $current_3ds_values = $this->get3dsValues();

            // check for Maestro 3-D Secure
            if ($settings['MODULE_3DS_ENABLE'] == '1'
                && isset($current_3ds_values['Enrolled'])
                && $current_3ds_values['Enrolled'] == 'Y')
            {
                $this->do3dsCmpiAuthenticate();

                $this->set3dsValues('PAResStatus', $this->response['PAResStatus']);
                $this->set3dsValues('Cavv', $this->response['Cavv']);
                $this->set3dsValues('Xid', $this->response['Xid']);
                $this->set3dsValues('EciFlag', $this->response['EciFlag']);

                if ($this->response['ErrorNo'] != '0'
                    || ($this->response['PAResStatus'] != 'Y' && $this->response['PAResStatus'] != 'A')
                    || $this->response['SignatureVerification'] != 'Y')
                {
                    // error, cmpi_authenticate didn't work properly
                    $msg = getxmsg('PM_PPP_UK_CC', 'MODULE_ERROR_3D_SECURE_GENERAL_ERROR');
                    if (trim($this->response['ErrorDesc']) != '')
                        $msg .= "\n<br />".$this->response['ErrorDesc'];

                    $this->setErrorMessage($msg);

                    $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                    modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "", array(), $paymentModule["validatedData"]);
                    $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
                    modApiFunc("Checkout", "saveState");

                    $request = new Request();
                    $request->setView  ('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ('step_id', $step_id_to_redirect_to);
                    $application->redirect($request);

                    return;
                }
            }

            $rawDprResult = $this->doDirectPaymentRequest();
            $result = $dprResult = $this->parseResponse($rawDprResult);
            $txn = ($result != false && isset($result["Result"])) ? $result["Result"] : false;
            if ($txn == 30) // TIMEOUT
            {
                $gsResult = $this->getStatusRequest($result["PNRef"]);
                if ($gsResult != false)
                {
                    $result = $gsResult;
                    $txn = $result["Result"];
                }
            }
        }
    //================================================================================================
    //                 APPROVED via doDirectRequest or getStatusRequest
    //================================================================================================
        if ($txn === "0") // APPROVED
        {
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            modApiFunc("Cart", "removeAllFromCart");

            $this->processData(array("_POST" => $result, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else
        {
    //================================================================================================
    //                 unsuccessful transaction, no reply
    //================================================================================================
            if ($txn === false)
            {
                $msg = $msgObj->getMessage("ERROR_NO_RESPONSE");
                $this->setErrorMessage($msg);
            }
    //================================================================================================
    //                 unsuccessful transaction, errors
    //================================================================================================
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT");
                $msg .= "\n<br />".$result["Message"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }

        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ('step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    function setResponse($response)
    {
        $this->response = $response;
    }

    function getResponse()
    {
        return $this->response;
    }

    function un_setResponse()
    {
        $this->response = array();
        if (modApiFunc('Session', 'is_Set', 'PaypalPro_UK_response'))
        {
            modApiFunc('Session', 'un_Set', 'PaypalPro_UK_response');
        }
    }

    /**
     * Processes data on updating the order status come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $msgRes = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");

        $msg = $this->OrderHistoryMessageTag."\n"
            .$this->gettime()."\n"
            .$msgRes->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_EVENT_DESCRIPTION')."\n"
            .$this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_LOG_POST_DATA')."\n"
            .print_r($data["_POST"], true);

        $txn = $data["_POST"]["Result"];
        if ($txn == 0)
        {
            $EventType = "ConfirmationSuccess";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
        }
        else if ($txn === false)
        {
            $msg .= $msgRes->getMessage('MODULE_PAYMENT_PAYPALPRO_LOG_POST_DATA')."\n"
                .print_r($data["_POST"], true);
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
            $EventType = "ConfirmationFailure";
        }
        else
        {
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
            $EventType = "ConfirmationFailure";
        }

        $this->clearPaypalPro_UKSession();
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_PaypalPro_UK_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Returns the data array, used for creating a new Person Info variant in the database.
     * in the database.
     *
     * @param string $infoType  - person info type, e.g. 'billinginfo'
     * @param string $forMethod  - for each method, e.g. for 'ExpressCheckout'
     * @return
     */
    function setPersonInfoVariant($infoType, $forMethod)
    {
        switch ($infoType)
        {
            case "billingInfo":
                  $infoTypeId = 2;
                  $variant_to_attributes = array("Firstname" => 1, "Lastname" => 2, "Email" => 3);//, "Country" => 9);
                  foreach ($variant_to_attributes as $view_tag => $id)
                  {
                      $variant_to_attributes[$view_tag] = array("person_attribute_id" => $id
                                                               ,"person_attribute_visible_name" => $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'.
                                                                                                                                       _ml_strtoupper($infoType).'_'.
                                                                                                                                       _ml_strtoupper($view_tag).'_NAME')
                                                               ,"person_attribute_description"  => $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'.
                                                                                                                                       _ml_strtoupper($infoType).'_'.
                                                                                                                                       _ml_strtoupper($view_tag).'_DESCR')
                                                               ,"person_attribute_unremovable"  => 1
                                                               ,"person_attribute_visible"      => 1
                                                               ,"person_attribute_required"     => 1
                                                               ,"person_attribute_sort_order"   => $id
                                                               );
                  }
                  break;
            default:
                  $infoTypeId = 1;
                  $variant_to_attributes = array();
                  break;
        }
        $variantId = modApiFunc("Checkout", "insertPersonInfoVariant",
                                            $infoTypeId,
                                            "PaypalPro_UK".$forMethod,
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_NAME'),
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_DESCR'),
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_VISIBLE_NAME'),
                                            $variant_to_attributes);
        return array("id" => $variantId, "tag" => "PaypalPro_UK".$forMethod);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_paypalpro_uk_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_paypal_setting_id'
               ,'key'               => $settings.'.pm_paypal_setting_key'
               ,'value'             => $settings.'.pm_paypal_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function get3DSRequestXml($fields)
    {
        $queryString = "<CardinalMPI>";
        foreach ($fields as $name => $value)
        {
            $queryString = $queryString."<".($name).">".($value)."</".($name).">" ;
        }
        $queryString = $queryString."</CardinalMPI>";
        return "cmpi_msg=".urlencode($queryString);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;

    var $CCInfo;

    var $paymentMethod;

    var $response;
    /**#@-*/

}
?>