<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * protx_form_cc_input_az view.
 *
 * @package PaymentModuleProtxFormCC
 * @author Egor Makarov
 */
class CheckoutPaymentModuleProtxFormCCInputAZ extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function CheckoutPaymentModuleProtxFormCCInputAZ()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-protx-form-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     * Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_Protx_Form_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME": $this->POST["ModuleName"] = $value; break;
                case "MODULE_VENDOR": $this->POST["ModuleVendor"] = $value; break;
                case "MODULE_PASSWORD": $this->POST["ModulePassword"] = $value; break;
                case "MODULE_USE_VENDOR_EMAIL":
                    if ($value == "1")
                    {
                        $this->POST["ModuleUseVendorEmail"] = "";
                    }
                    break;
                case "MODULE_VENDOR_EMAIL": $this->POST["ModuleVendorEmail"] = $value; break;
                case "MODULE_ALLOW_GIFT_AID": $this->POST["ModuleAllowGiftAid"] = $value; break;
                case "MODULE_APPLY_AVSCV2": $this->POST["ModuleApplyAVSCV2"] = $value; break;
                case "MODULE_APPLY_3D_SECURE": $this->POST["ModuleApply3DSecure"] = $value; break;
                case "MODULE_MODE" : $this->POST["ModuleMode"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_Protx_Form_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_protx_form/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_protx_form/", "status.tpl.html", array());
        return $retval;
    }

    /**
     *
     */
    function outputOrderStatus()
    {
        global $application;
        $retval = "";
        for ($i = 1; $i < 5; $i++)
        {
            $retval.= "<option value=\"$i\" ";
            $retval.= ($this->POST["ModuleOrderStatusId"] == $i)? "SELECTED " : "";
            $retval.= ">" . $this->MessageResources->getMessage('MODULE_ORDER_STATUS_00'.$i) . "</option>";
        }
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_protx_form/", "status.tpl.html", array());
        return $retval;
    }

    function outputModeOptions()
    {
        $retval = "";
        $options = array
            (
                array("value" => "1", "text" => $this->MessageResources->getMessage('MODE_001')),
                array("value" => "2", "text" => $this->MessageResources->getMessage('MODE_002')),
                array("value" => "3", "text" => $this->MessageResources->getMessage('MODE_003')),
                array("value" => "4", "text" => $this->MessageResources->getMessage('MODE_004')),
            );
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleMode"]? "selected":"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    function outputAllowGiftAidOptions()
    {
        $retval = "";
        $options = array
            (
                 array("value" => "9", "text" => $this->MessageResources->getMessage('GIFT_AID_000'))
                ,array("value" => "0", "text" => $this->MessageResources->getMessage('GIFT_AID_001'))
                ,array("value" => "1", "text" => $this->MessageResources->getMessage('GIFT_AID_002'))
            );
        foreach ($options as $option)
        {
            $checked = $option["value"] == $this->POST["ModuleAllowGiftAid"] ? "checked" : "";
            $retval .= "<input type='radio' name='ModuleAllowGiftAid' value='{$option["value"]}' {$checked}>{$option["text"]}<br>";
        }
        return $retval;
    }

    function outputApplyAVSCV2Options()
    {
        $retval = "";
        $options = array
            (
                 array("value" => "9", "text" => $this->MessageResources->getMessage('AVSCV2_000'))
                ,array("value" => "0", "text" => $this->MessageResources->getMessage('AVSCV2_001'))
                ,array("value" => "1", "text" => $this->MessageResources->getMessage('AVSCV2_002'))
                ,array("value" => "2", "text" => $this->MessageResources->getMessage('AVSCV2_003'))
                ,array("value" => "3", "text" => $this->MessageResources->getMessage('AVSCV2_004'))
            );
        foreach ($options as $option)
        {
            $checked = $option["value"] == $this->POST["ModuleApplyAVSCV2"] ? "checked" : "";
            $retval .= "<input type='radio' name='ModuleApplyAVSCV2' value='{$option["value"]}' {$checked}>{$option["text"]}<br>";//</option>";
        }
        return $retval;
    }

    function outputApply3DSecureOptions()
    {
        $retval = "";
        $options = array
            (
                 array("value" => "9", "text" => $this->MessageResources->getMessage('SECURE_3D_000'))
                ,array("value" => "0", "text" => $this->MessageResources->getMessage('SECURE_3D_001'))
                ,array("value" => "1", "text" => $this->MessageResources->getMessage('SECURE_3D_002'))
                ,array("value" => "2", "text" => $this->MessageResources->getMessage('SECURE_3D_003'))
                ,array("value" => "3", "text" => $this->MessageResources->getMessage('SECURE_3D_004'))
            );
        foreach ($options as $option)
        {
            $checked = $option["value"] == $this->POST["ModuleApply3DSecure"] ? "checked" : "";
            $retval .= "<input type='radio' name='ModuleApply3DSecure' value='{$option["value"]}' {$checked}>{$option["text"]}<br>";
        }
        return $retval;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_protx_form");
        $form_action = $request->getURL();

        $template_contents = array(
                                    "EditProtxForm"         => $HtmlForm1->genForm($form_action, "POST", "EditProtxForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()

                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleMethodNameFieldName" => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldHint"  => $this->Hints->getHintLink(array('MODULE_DESCR_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleDescrField"      => $HtmlForm1->genInputTextAreaField("75", "ModuleDescr", "5")
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage("MODULE_DESCR")

                                   ,"ModuleVendorFieldName"  => $this->MessageResources->getMessage('MODULE_VENDOR_FIELD_NAME')
                                   ,"ModuleVendorFieldHint"  => $this->Hints->getHintLink(array('MODULE_VENDOR_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleVendorField"      => $HtmlForm1->genInputTextField("128", "ModuleVendor", "30", prepareHTMLDisplay($this->POST["ModuleVendor"]))

                                   ,"ModulePasswordFieldName"  => $this->MessageResources->getMessage('MODULE_PASSWORD_FIELD_NAME')
                                   ,"ModulePasswordFieldHint"  => $this->Hints->getHintLink(array('MODULE_PASSWORD_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModulePasswordField"      => $HtmlForm1->genInputTextField("128", "ModulePassword", "30", prepareHTMLDisplay($this->POST["ModulePassword"]))

                                   ,"ModuleUseVendorEmailField"   => $this->genInputCheckBox("ModuleUseVendorEmail", array_key_exists("ModuleUseVendorEmail", $this->POST), $this->MessageResources->getMessage("MODULE_USE_VENDOR_EMAIL_TEXT"))

                                   ,"ModuleVendorEmailFieldName"  => $this->MessageResources->getMessage('MODULE_VENDOR_EMAIL_FIELD_NAME')
                                   ,"ModuleVendorEmailFieldHint"  => $this->Hints->getHintLink(array('MODULE_VENDOR_EMAIL_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleVendorEmailField"      => $HtmlForm1->genInputTextField("128", "ModuleVendorEmail", "30", prepareHTMLDisplay($this->POST["ModuleVendorEmail"]))

                                   ,"ModuleAllowGiftAidFieldName"  => $this->MessageResources->getMessage('MODULE_ALLOW_GIFT_AID_FIELD_NAME')
                                   ,"ModuleAllowGiftAidFieldHint"  => $this->Hints->getHintLink(array('MODULE_ALLOW_GIFT_AID_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleAllowGiftAidOptions"      => $this->outputAllowGiftAidOptions()

                                   ,"ModuleApplyAVSCV2FieldName"    => $this->MessageResources->getMessage('MODULE_APPLY_AVSCV2_FIELD_NAME')
                                   ,"ModuleApplyAVSCV2FieldHint"    => $this->Hints->getHintLink(array('MODULE_APPLY_AVSCV2_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleApplyAVSCV2Options"      => $this->outputApplyAVSCV2Options()

                                   ,"ModuleApply3DSecureFieldName"    => $this->MessageResources->getMessage('MODULE_APPLY_3D_SECURE_FIELD_NAME')
                                   ,"ModuleApply3DSecureFieldHint"    => $this->Hints->getHintLink(array('MODULE_APPLY_3D_SECURE_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleApply3DSecureOptions"      => $this->outputApply3DSecureOptions()

                                   ,"ModuleModeFieldName"    => $this->MessageResources->getMessage('MODULE_MODE_FIELD_NAME')
                                   ,"ModuleModeFieldHint"    => $this->Hints->getHintLink(array('MODULE_MODE_FIELD_NAME', 'payment-module-protx-form-messages'))
                                   ,"ModuleModeOptions"      => $this->outputModeOptions()

                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   //,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   //,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   //,"Alert_004"             => $this->MessageResources->getMessage('ALERT_003')

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()
                                   );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_protx_form/", "list.tpl.html", array());
    }

    /**
     *
     */
    function genInputCheckBox($name, $checked, $text)
    {
        $retval = "name=\"{$name}\" " . ($checked ? " checked " : "") . " value=\"{$text}\"";
        return $retval;
    }

    /**
     * Returns the tag output, whose name is specified in $tag.
     */
    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
            $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>