<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModulePsigateDirectCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_PsigateDirect_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModuleYourpay  constructor.
     */
    function Payment_Module_PsigateDirect_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-direct-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }
    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'PsigateDirectErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'PsigateDirectErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'PsigateDirectErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'PsigateDirectErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'PsigateDirectErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-direct-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_PSIGATE_DIRECT_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_YOURPAY_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_PsigateDirect_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-direct-messages", "AdminZone");

        $tables = Payment_Module_PsigateDirect_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_psigate_direct_settings';            #
        $columns = $tables[$table]['columns'];  #

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("STORE_ID", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('STORE_ID')).':"'.$obj->getMessage('STORE_ID').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("PASSPHRASE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('PASSPHRASE')).':"'.$obj->getMessage('PASSPHRASE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("GATEWAY_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL')).':"'.$obj->getMessage('GATEWAY_URL').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("BILLING_INFO", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('BILLING_INFO')).':"'.$obj->getMessage('BILLING_INFO').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage("MODULE_MODE")).':"'.$obj->getMessage("MODULE_MODE").'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_PsigateDirect_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // PSiGate Direct UID
//        return "6FF88488-1214-455C-BB10-C971FDEF4ED3";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-direct-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "psigate_direct_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModulePsigateDirectCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModulePsigateDirectCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_psigate_direct_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_psigate_direct_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_psigate_direct_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_psigate_direct_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_psigate_direct_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_psigate_direct_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL();

        $confirmationData = array
            (
                "FormAction" => $self_link
                ,"FormMethod" => "POST"
                ,"DataFields" => array()
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-psigate-direct-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        if (isset($data["_POST"]["OrderID"]))
        {
        	modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $data["_POST"]["OrderID"]);
        }
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_PSIGATE_DIRECT_LOG_EVENT_DESCRIPTION') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_PSIGATE_DIRECT_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["ErrMsg"])
        	&& $data["_POST"]["ErrMsg"] == ''
        	&& isset($data["_POST"]["Approved"])
        	&& _ml_strtoupper($data["_POST"]["Approved"]) == "APPROVED")
       	{
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_PsigateDirect_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_PsigateDirect_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');
        loadCoreFile('bouncer.php');
        loadCoreFile('obj_xml.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $settings = $this->getSettings();
        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());

    //===============================================================
    // ====================================== billing template ======
        $billingTemplate = "";
        if ($settings["BILLING_INFO"] == 1)
        {
            $dataFields = array(
                    "USERID"				=> $billingInfo->getByMask("Email")
                   ,"BNAME"                 => $billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname")
                   ,"BADDRESS1"	            => $billingInfo->getByMask("Streetline1")
                   ,"BADDRESS2"	            => $billingInfo->getByMask("Streetline2")
                   ,"BCITY"	                => $billingInfo->getByMask("City")
                   ,"BPROVINCE"	            => modApiFunc("Location", "getState", $billingInfo->getByMask("Statemenu"))
                   ,"BZIP"	                => $billingInfo->getByMask("Postcode")
                   ,"BCOUNTRY"	            => modApiFunc("Location", "getCountry", $billingInfo->getByMask('Country'))
                   ,"PHONE"	                => $billingInfo->getByMask("Phone")
                   ,"EMAIL"	                => $billingInfo->getByMask("Email")
                   ,"COMMENT"               => $billingInfo->getByMask("CommentLine")
                   ,"SNAME"				    => $shippingInfo->getByMask("Firstname")." ".$shippingInfo->getByMask("Lastname")
                   ,"SADDRESS1"			    => $shippingInfo->getByMask("Streetline1")
                   ,"SADDRESS2"				=> $shippingInfo->getByMask("Streetline2")
                   ,"SCITY"					=> $shippingInfo->getByMask("City")
                   ,"SPROVINCE"				=> modApiFunc("Location", "getState", $shippingInfo->getByMask("Statemenu"))
                   ,"SZIP"			        => $shippingInfo->getByMask("Postcode")
                   ,"SCOUNTRY"				=> modApiFunc("Location", "getCountry", $shippingInfo->getByMask('Country'))
                   );
            $billingTemplate = file_get_contents(dirname(__FILE__)."/includes/billingInfoRequest.xml");
            $billingTemplate = strtr($billingTemplate, $dataFields);
        }

    //===================================================================
    //========================================= card info ===============

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        // notice: a two-digit year
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";

    //===================================================================
    //======================================== module mode ===============
        switch ($settings["MODULE_MODE"])
        {
            case "1":
                $moduleMode = "<TestResult>A</TestResult>";
                break;

            case "2":
                $moduleMode = "<TestResult>D</TestResult>";
                break;

            case "3":
                $moduleMode = "<TestResult>R</TestResult>";
                break;

            case "4":
                $moduleMode = "<TestResult>F</TestResult>";
                break;

            default:
                $moduleMode = "";
                break;
        }

    //===================================================================
    //======================================== items ====================

        $products = modApiFunc("Cart", "getCartContent", $currencyId);
        $items = "";
        foreach ($products as $item)
        {
            $itemName = prepareHTMLDisplay($item["Name"]);
            $itemDescr = (_ml_strlen($item["ShortDescription"]) > 100)
                ?
                _ml_substr($item["ShortDescription"], 0, 97)."..."
                :
                $item["ShortDescription"];
            $itemDescr = prepareHTMLDisplay($itemDescr);

            $items .= "<Item>".
        		"\n\t\t<ItemID>{$itemName}</ItemID>".
        		"\n\t\t<ItemDescription>{$itemDescr}</ItemDescription>".
        		"\n\t\t<ItemQty>{$item["Quantity_In_Cart"]}</ItemQty>".
        		"\n\t\t<ItemPrice>{$item["CartItemSalePrice"]}</ItemPrice>".
        	"\n\t</Item>";
        }
        $discount["SubtotalGlobalDiscount"]["descr"]    = "Subtotal Global Discount";
        $discount["SubtotalGlobalDiscount"]["value"]    = - $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "SubtotalGlobalDiscount",    $currencyId));
        $discount["QuantityDiscount"]["descr"]          = "Quantity Discount";
        $discount["QuantityDiscount"]["value"]          = - $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "QuantityDiscount",          $currencyId));
        $discount["SubtotalPromoCodeDiscount"]["descr"] = "Subtotal Promo Code Discount";
        $discount["SubtotalPromoCodeDiscount"]["value"] = - $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "SubtotalPromoCodeDiscount", $currencyId));
        foreach ($discount as $disc)
        {
            if ($disc["value"] == 0) continue;

            $items .= "<Item>".
        		"\n\t\t<ItemID>Discount</ItemID>".
        		"\n\t\t<ItemDescription>{$disc["descr"]}</ItemDescription>".
        		"\n\t\t<ItemQty>1</ItemQty>".
        		"\n\t\t<ItemPrice>{$disc["value"]}</ItemPrice>".
        	"\n\t</Item>";
        }

    //===================================================================
    //================================ totals, currency =================

        $chargeTotal = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                 $currencyId));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                   $currencyId));
        $shipping    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currencyId));
        $subtotal    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal",    $currencyId));

    //===================================================================
    //================================= bouncer =========================
        $dataFields = array
            (
                "STORE_ID"	            => $settings["STORE_ID"]
               ,"PASSPHRASE"	        => $settings["PASSPHRASE"]
               ,"<MODULE_MODE/>"		=> $moduleMode
               ,"<BILLING_INFO/>"		=> $billingTemplate
               ,"<ITEMS/>"		        => $items
               ,"TAX1"	                => $tax
               ,"SHIPPING_TOTAL"	    => $shipping
               ,"SUBTOTAL"	            => $subtotal
               ,"CARDNUM"	            => $cardNumber
               ,"CARDEXPMONTH"	        => $cardExpMonth
               ,"CARDEXPYEAR"	        => $cardExpYear
               ,"CARDCVV"	            => $CVM
               ,"CUSTOMER_IP"	        => $_SERVER['REMOTE_ADDR']
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);

        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["GATEWAY_URL"]);
        $bnc->setPOSTstring($xml_content);
        $result = $bnc->RunRequest();

    //===================================================================
    //===================================== transaction result ==========
        $trxResult = "";
        $arrRlt = array();
        $result = explode("</", "r_smth>".$result["body"]);
        foreach ($result as $k => $val)
        {
            $val = explode("<", $val);
            if (isset($val[1]))
            {
                $val = explode(">", $val[1]);
                $arrRlt[$val[0]] = $val[1];
            }
        }
        if (isset($arrRlt["Approved"]))
        {
            $trxResult = $arrRlt["Approved"];
        }

    //===================================================================
    //================================ processing results ===============

        $msgObj = $application->getInstance("MessageResources", "payment-module-psigate-direct-messages", "AdminZone");
        if ($trxResult == "APPROVED")
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $arrRlt, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if ($trxResult == "")
	        {
	            // couldn't reach PSiGate Gateway,
	            // looks like wrong gateway settings
	            $msg = $msgObj->getMessage("ERROR_NO_RESPONCE");
                $this->setErrorMessage($msg);
	        }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT")
                    .$arrRlt["Approved"];
                if ($arrRlt["ErrMsg"] != '') $msg .= "<br />Error: ".$arrRlt["ErrMsg"];
                if ($arrRlt["ReturnCode"] != '') $msg .= "<br />Return Code: ".$arrRlt["ReturnCode"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
            return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_psigate_direct_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_psigate_direct_setting_id'
               ,'key'               => $settings.'.pm_psigate_direct_setting_key'
               ,'value'             => $settings.'.pm_psigate_direct_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        PsigateDirect                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-psigate-direct--messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PSIGATE_DIRECT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>