<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("STRATAPAY_URL", "https://www.stratapay.com.au/paypage.aspx");

define("STRATAPAY_PAYMENT_VERIFICATION_WEB_SERVICE_URL", "https://www.stratapay.com.au/ecommservices.asmx");

define ("STRATAPAY_PAYMENT_VERIFICATION_WEB_SERVICE_SOAP_ACTION", "http://tempuri.org/stratapayMKII/eCommServices/checkPaymentComplex");
/**
 *
 * @package PaymentModuleStratapay
 * @author Vadim Lyalikov
 */
class Payment_Module_Stratapay extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }
    /**
     * PaymentModuleStratapay  constructor.
     */
    function Payment_Module_Stratapay()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" .
///        $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_MODULE_NAME') .
        $this->Settings["MODULE_NAME"];// .
//        $obj->getMessage('MODULE_NAME');
    }


    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Stratapay::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");

        $tables = Payment_Module_Stratapay::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_stratapay_settings';            #
        $columns = $tables[$table]['columns'];  #

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_STRATAPAY_NUMBER", $columns['key']);
        $query->addInsertValue('s:9:"100050016"', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_EMAIL", $columns['key']);
        $query->addInsertValue('s:20:"you@yourbusiness.com";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:8:"password";', $columns['value']);
        $application->db->getDB_Result($query);
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "77CAAF04-05CB-3BA8-FD15-0BDEC73E230D";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "stratapay_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleStratapayInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleStratapayOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_stratapay_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_stratapay_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_stratapay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_stratapay_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_stratapay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_stratapay_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     *            POST         ,                         StrataPay:
     * StrataPay merchant Number                     Order Id ('invoice number'            StrataPay)
     */
    function getStringStrataPayNumber($orderId)
    {
        global $application;
        $this->getSettings();
        return $this->Settings["MODULE_STRATAPAY_NUMBER"] . $orderId;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currencyId);

        $confirmationData = array
            (
                //"FormAction" => STRATAPAY_URL
                "FormMethod" => "POST"
               ,"DataFields" => array
                    (
                        "stringStrataPayNumber" => $this->getStringStrataPayNumber($orderId)
                       ,"decimalAmount" => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId))
                       ,"successURL" => $self_link ."&status=success"
                       ,"failURL" => $self_link ."&status=fail"
                    )
            );

        $confirmationData['FormAction'] = STRATAPAY_URL;
        return $confirmationData;
    }

    //                                           Receipt Number
    function parsePayIDfromGatewayResponse($post_data)
    {
        if(isset($post_data['response']))
        {
            $text = $post_data['response'];
            $regexp = "/Tax Receipt #([0-9]+)/";
            if(preg_match($regexp, $text, $matches) == 1)
            {
                return $matches[1];
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    /**
     *
     */
    function doPaymentVerificationsRequest($post_data, $order_id)
    {
        global $application;
        $this->getSettings();

        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");
        // read the post from Stratapay system

        //                                     .
        $result = array("payment_status" => array());

        $pay_id = $this->parsePayIDfromGatewayResponse($post_data);
        //:          $post_data['response']      .                                                  .
        if($pay_id === false)
        {
            //                                  .                Reciept Number
            //:                      .      .
            modApiFunc("Checkout", "addOrderHistory", $order_id, $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_002'));
        }
        else
        {
            $post_data = file_get_contents(dirname(__FILE__)."/includes/doPaymentVerificationSOAPRequest.xml");
            $post_data = str_replace("AUTH_ID", $this->Settings["MODULE_EMAIL"], $post_data);
            $post_data = str_replace("PASSWORD", $this->Settings["MODULE_PASSWORD"], $post_data);
            $post_data = str_replace("TIMESTAMP", time(), $post_data);
            $post_data = str_replace("PAY_ID", $pay_id, $post_data);
            $post_data = str_replace("INVOICE_NUMBER", $order_id, $post_data);

            // post to Stratapay system to validate
            loadCoreFile('bouncer.php');
            global $application;
            $bnc = new Bouncer();
            $bnc->setMethod("POST");
            $bnc->setHTTPversion($application->getAppIni('STRATAPAY_VERIFY_STATUS_HTTP_PROTOCOL_VERSION'));
            $bnc->setURL($application->getAppIni('STRATAPAY_VERIFY_STATUS_SERVER_URL'));
            $bnc->setPOSTtype("text/xml; charset=utf-8");

            $bnc->setAdditionalHeaders(array("SOAPAction"=>"\"".STRATAPAY_PAYMENT_VERIFICATION_WEB_SERVICE_SOAP_ACTION."\""));

            $bnc->setPOSTstring($post_data);
            $result=$bnc->RunRequest();

            if($result==false)
            {
                //if($this->is_debug==true)
                //    $this->_debug_info[]=array("Error",$bnc->getLastErrorMessage());
                //return $_rates;
                //                                  .                     .
                //:                      .      .
                modApiFunc("Checkout", "addOrderHistory", $order_id, $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_008') . $bnc->getLastErrorMessage());
            }
            else
            {
                //
                modApiFunc("Checkout", "addOrderHistory", $order_id, $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_009') . $result["body"]);

                //                .
                $text = $result["body"];

                $regexp = "/\<authID\>(.*)\<\/authID\>/";
                if(preg_match($regexp, $text, $matches) == 1)
                {
                    $response_auth_id = $matches[1];
                }
                else
                {
                    $response_auth_id = false;
                }

                $regexp = "/\<checkPaymentComplexResult\>(.*)\<\/checkPaymentComplexResult\>/";
                if(preg_match($regexp, $text, $matches) == 1)
                {
                    $response_complex_result = $matches[1];
                }
                else
                {
                    $response_complex_result = false;
                }

                if($response_complex_result === false ||
                   $response_complex_result == 0 ||
                   $response_complex_result == "0" ||
                   $response_complex_result == "0.00")// ||
//                   $response_auth_id === false ||
//                   $response_auth_id != $this->Settings["MODULE_EMAIL"])
                {
                    //      .               .
                    modApiFunc("Checkout", "addOrderHistory", $order_id, $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_010') . "response_complex_result='".$response_complex_result."' response_auth_id='".$response_auth_id."'");
                }
                else
                {
                    //                                      .          ,
                    //               .                               .
                    //                      .
                    $historyMessage =  $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_011');
                    $paymentStatusId = 2; //fully paid
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, $paymentStatusId, $historyMessage);
                }
            }
        }
        return $result;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-stratapay-messages", "AdminZone");
        //the first step of data processing from the Payment Gateway
        //the payment status update.
        //the next step.
        //do not call the Payment Gateway .
        $DBPaymentStatus = array();
        $status = $data["_GET"]["status"];

        modApiFunc("Checkout", "addOrderHistory", $order_id, $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_001') . "'" . $data["_POST"]['response'] . "'");

        switch ($status)
        {
            //No background events. Stratapay server never does call eshop to confirm payment status.
            case "success":
                $EventType = "ConfirmationSuccess";
                //                                                 .
                $result = $this->doPaymentVerificationsRequest($data["_POST"], $order_id);
                //$result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1,
                //           $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_006'));
                break;

            case "fail":
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                           $this->OrderHistoryMessageTag . $this->getmicrotime() . "\n" . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_IPN_LOG_EVENT_DESCRIPTION') . $obj->getMessage('MODULE_PAYMENT_STRATAPAY_STRATAPAY_LOG_MESSAGE_AZ_007'));
                break;
            default:
                //: Report Error: e.g. write to order history
                $result = array("payment_status" => array());
                break;
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Stratapay::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        _debug(__CLASS__ .'::'. __FUNCTION__, 'message', 'BEGIN');

        $query = new DB_Table_Delete(Payment_Module_Stratapay::getTables());
        global $application;
        $application->db->getDB_Result($query);

        _debug(__CLASS__ .'::'. __FUNCTION__, 'message', 'END');
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_stratapay_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_stratapay_setting_id'
               ,'key'               => $settings.'.pm_stratapay_setting_key'
               ,'value'             => $settings.'.pm_stratapay_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>