<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleTranzilaCC
 * @author Egor V. Derevyankin
 */

class Payment_Module_Tranzila_CC extends pm_sm_api
{
    function Payment_Module_Tranzila_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-tranzila-messages", "AdminZone");

        $sets = $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_TRANZILA_LOG_MODULE_ID') .
                $this->getUID() . "\n" . $sets["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'ILS'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function install()
    {
        global $application;
        loadCoreFile('csv_parser.php');
        $csv_parser = new CSV_Parser();

        $tables = Payment_Module_Tranzila_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_tranzila_settings';
        $columns = $tables[$table]['columns'];

        list($flt,$Default_Settings) = $csv_parser->parse_file(dirname(__FILE__)."/includes/default_settings.csv");
        if(count($Default_Settings) > 0)
        {
            foreach($Default_Settings as $key => $setting)
            {
                $query = new DB_Insert($table);
                $query->addInsertValue($setting["key"], $columns['setting_key']);
                $query->addInsertValue($setting["value"], $columns['setting_value']);
                $application->db->getDB_Result($query);
            };
        };

        $table = 'pm_tranzila_responses';
        $columns = $tables[$table]['columns'];

        list($flt,$responses) = $csv_parser->parse_file(dirname(__FILE__)."/includes/responses.csv");
        if(count($responses) > 0)
        {
            foreach($responses as $key => $response)
            {
                $query = new DB_Insert($table);
                $query->addInsertValue($response['code'], $columns['code']);
                $query->addInsertValue($response['text'], $columns['text']);
                $application->db->getDB_Result($query);
            };
        };


        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager','addEventHandler','RemovePersonInfoTypeEvent',__CLASS__,'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_EWay_CC                    2 PersonInfoType' :
     * billingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-tranzila-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_TRANZILA_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Tranzila_CC::getTables());
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array();

        $table = 'pm_tranzila_settings';
        $tables[$table] = array(
            'columns' => array(
                'setting_id'    => $table.'.setting_id'
               ,'setting_key'   => $table.'.setting_key'
               ,'setting_value' => $table.'.setting_value'
             )
           ,'types'   => array(
                'setting_id'    => DBQUERY_FIELD_TYPE_INT.' NOT NULL auto_increment'
               ,'setting_key'   => DBQUERY_FIELD_TYPE_CHAR255.' NOT NULL'
               ,'setting_value' => DBQUERY_FIELD_TYPE_CHAR255.' NOT NULL'
             )
           ,'primary' => array(
                'setting_id'
             )
        );

        $table = 'pm_tranzila_responses';
        $tables[$table] = array(
            'columns' => array(
                'id'    => $table.'.id'
               ,'code'  => $table.'.code'
               ,'text'  => $table.'.text'
             )
           ,'types'   => array(
                'id'    => DBQUERY_FIELD_TYPE_INT.' NOT NULL auto_increment'
               ,'code'  => DBQUERY_FIELD_TYPE_CHAR5.' NOT NULL'
               ,'text'  => DBQUERY_FIELD_TYPE_CHAR255.' NOT NULL default \'\''
             )
           ,'primary' => array(
                'id'
             )
        );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUID()
    {
//        return '9A8B1FE7-C7A8-4300-8282-DD80F880FBB0';
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;

        $MR = &$application->getInstance('MessageResources','payment-module-tranzila-messages','AdminZone');

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $MR->getMessage('MODULE_NAME'),
                     "Description" => $MR->getMessage('MODULE_DESCR'),
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$MR->getMessage('MODULE_STATUS_ACTIVE')."</span>":$MR->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleTranzilaCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleTranzilaCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleTranzilaCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    function getSettings()
    {
        $res = execQuery('SELECT_PM_SM_SETTINGS2',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_tranzila_settings'));
        $settings=array();

        foreach($res as $k => $sval)
            $settings[$sval['setting_key']]=$sval['setting_value'];

        return $settings;
    }

    function updateSettings($settings)
    {
        global $application;
        $tables=$this->getTables();
        $stable=$tables['pm_tranzila_settings']['columns'];

        foreach($settings as $skey => $sval)
        {
            $query = new DB_Update('pm_tranzila_settings');
            $query->addUpdateValue($stable['setting_value'],$sval);
            $query->WhereValue($stable['setting_key'], DB_EQ, $skey);
            $application->db->PrepareSQL($query);
            $application->db->DB_Exec();
        };

        return;
    }

    function getPaymentMode()
    {
        return 'direct';
    }

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    function backgroundProcess($type="direct", $transactionData = null)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $settings = $this->getSettings();

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID");

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $params = array(
            'supplier' => $settings['SUPPLIER']
           ,'first_name' => $billingInfo->getByMask('Firstname')
           ,'last_name' => $billingInfo->getByMask('Lastname')
           ,'sum' => number_format($this->export_PRICE_N_A(modApiFunc('Checkout', 'GetOrderPrice', 'Total', $currency_id)), 2, '.', '')
           ,'currency' => $this->__getTranzilaCurrencyCodeByISOCode(modApiFunc("Localization", "getCurrencyCodeById", $currency_id))
           ,'cred_type' => 1 // Regular credit
           ,'ccno' => $CCInfo['CreditCardNumber']['value']
           ,'mycvv' => $CCInfo['CreditCardVerificationNumber']['value']
           ,'expmonth' => $CCInfo['ExpirationMonth']['value']
           ,'expyear' => _ml_substr($CCInfo['ExpirationYear']['value'], 2, 2)
        );

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod("POST");
        $bnc->setURL(TRANZILA_GATEWAY_URL);
        $bnc->setPOSTstring($bnc->prepareDATAstring($params));

        $result = $bnc->RunRequest();

        if($result != false)
        {
            $string = $result['body'];

            $res_array = array();
            parse_str($string, $res_array);

            switch($res_array['Response'])
            {
                case TRANZILA_SUCCESSFUL_CODE:  // Accepted
                    $order_id = modApiFunc('Checkout', 'createOrderInDB');
                    //                .
                    //
                    modApiFunc('Cart', 'removeAllFromCart');

                    $MR = &$application->getInstance('MessageResources','payment-module-tranzila-messages','AdminZone');

                    $msg = $MR->getMessage('MODULE_PAYMENT_TRANZILA_LOG_MODULE_ID') . "\n" .
                        $this->getUID() . "\n" .
                        $this->getmicrotime() . "\n" .
                        $settings['MODULE_NAME'] . " ".
                        $MR->getMessage('MODULE_PAYMENT_TRANZILA_LOG_EVENT_DESCRIPTION') .
                        $MR->getMessage('MODULE_PAYMENT_TRANZILA_LOG_MESSAGE_ACCEPTED') . "\n" .

                    // update order info
                    modApiFunc('Checkout', 'updateOrderPaymentProcessorOrderID', $order_id, $res_array['index']);
                    modApiFunc('Checkout', 'UpdatePaymentStatusInDB', $order_id, ORDER_PAYMENT_STATUS_FULLY_PAID, $msg);

                    $step_id_to_redirect_to = modApiFunc('Checkout', 'getCurrentStepID') + 1;
                    break;
                default:
                    modApiFunc('Session','set','Tranzila_ErrorMessage',$this->__getResponseTextByCode($res_array['Response']));
                    $paymentModule = modApiFunc('Checkout', 'getPrerequisiteValidationResults', 'paymentModule');
                    modApiFunc('Checkout', 'setPrerequisitesValidationResultsItem', 'paymentModule', '', false, 'CHECKOUT_ERR_005', array(), $paymentModule['validatedData']);
                    $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc('Checkout', 'getCurrentStepID'));
                    modApiFunc('Checkout', 'saveState');
                    break;
            };

        };

        $request = new Request();
        $request->setView('CheckoutView');
        $request->setAction('SetCurrStep');
        $request->setKey('step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    function getmicrotime()
    {
        global $application;
        list($usec, $sec) = explode(" ", microtime());

        $MR = &$application->getInstance('MessageResources','payment-module-tranzila-messages','AdminZone');

        return $MR->getMessage('MODULE_PAYMENT_TRANZILA_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $MR->getMessage('MODULE_PAYMENT_TRANZILA_SECONDS');
    }

    function __getResponseTextByCode($code)
    {
        global $application;
        $tables = $this->getTables();

        $rsps_table = $tables['pm_tranzila_responses']['columns'];

        $query = new DB_Select();
        $query->addSelectField($rsps_table['text'], 'text');
        $query->addSelectTable('pm_tranzila_responses');
        $query->WhereValue($rsps_table['code'], DB_EQ, $code);

        $res = $application->db->getDB_Result($query);

        return (count($res) == 1 ? $res[0]['text'] : '');
    }

    function __getTranzilaCurrencyCodeByISOCode($iso_code)
    {
        switch($iso_code)
        {
            case 'ILS': return 1; break;
            case 'USD': return 2; break;
            case 'GBP': return 3; break;
            case 'HKD': return 5; break;
            case 'JPY': return 6; break;
            case 'EUR': return 7; break;
            default: return 1; break;
        };
    }
}
?>