<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 *
 * @package PaymentModuleWebpayCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Webpay_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Payment_Module_Webpay_CC constructor.
     */
    function Payment_Module_Webpay_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_WEBPAY_SECONDS');
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'WebpayErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'WebpayErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'WebpayErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMsg($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMsg()
    {
        return $this->errorMessage;
    }

    function unsetErrorMsg()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'WebpayErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'WebpayErrorMessage');
        }
    }

    function setPCK($pck, $oid)
    {
        modApiFunc('Session', 'set', 'WebpayPaymentClusterKey', $pck);
        modApiFunc('Session', 'set', 'WebpayPaymentClusterOid', $oid);
    }

    function getPCK($oid)
    {
        if (modApiFunc('Session', 'is_Set', 'WebpayPaymentClusterKey'))
        {
            $saved_oid = false;
            $pck = modApiFunc('Session', 'get', 'WebpayPaymentClusterKey');
            if (modApiFunc('Session', 'is_Set', 'WebpayPaymentClusterOid'))
            {
                $saved_oid = modApiFunc('Session', 'get', 'WebpayPaymentClusterOid');
            }

            if ($saved_oid == $oid)
                return $pck;
        }

        return false;
    }

    function clearPCK()
    {
        if(modApiFunc('Session', 'is_Set', 'WebpayPaymentClusterKey'))
        {
            modApiFunc('Session', 'un_Set', 'WebpayPaymentClusterKey');
        }
        if(modApiFunc('Session', 'is_Set', 'WebpayPaymentClusterOid'))
        {
            modApiFunc('Session', 'un_Set', 'WebpayPaymentClusterOid');
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Webpay_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");

        $tables = Payment_Module_Webpay_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_webpay_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_CLIENT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_CERTIFICATE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_URL')).':"'.$obj->getMessage('MODULE_URL').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_PORT", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_CERTIFICATE_PATH", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Webpay_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Webpay_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_WEBPAY_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Webpay GUID
//        return "EB2D55E7-20D0-49DC-9773-F5021F2D8F03";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleWebpayCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleWebpayCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleWebpayCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_webpay_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_webpay_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_webpay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_webpay_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_webpay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_webpay_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }


    /**
     * parses XML tags, seeks for tags given in $fields
     *
     * @param string array $fields
     * @param string $raw
     * @return unknown
     */

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        foreach ($fields as $tag => $val)
        {
            $xml_tag = $xml->document->findChildRecursively($tag);
            if ($xml_tag != FALSE)
            {
                if (count($xml_tag->attributes) == 1)
                    $fields[$tag] = $xml_tag->attributes;
                else
                    $fields[$tag] = $xml_tag->attributes;
            }
        }

        return $fields;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "id" => ""
            ,"key" => ""
            ,"error" => ""
        );

        return $this->parseXmlTags($fields, $raw);
    }

    /**
     * proceeds status_payment_cluster request
     *
     */
    function getStatusPaymentCluster($orderId)
    {
        global $application;
        $settings = $this->getSettings();
        $key = $this->getPCK($orderId);

        $fields = array(
                 "command"             => "status_payment_cluster"
                ,"merchant_name"       => $settings["MODULE_MERCHANT_NAME"]
                ,"merchant_password"   => $settings["MODULE_MERCHANT_PASSWORD"]
                ,"report_type"         => "txt_simple2"
                ,"payment_cluster_key" => $key
            );

    //================================ logging ===============================

        $msgObj = $application->getInstance("MessageResources", "payment-module-webpay-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_GET_STATUS"), $fields);

    //================================ logging ===============================

        $content = "";
        foreach ($fields as $key => $value) {
            $content .= $key . '=' . urlencode($value) . '&';
        }

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_URL"]);
        $bnc->setPOSTstring($content);
        $result = $bnc->RunRequest();

    //================================ logging ===============================

        $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_GET_STATUS_RESULT"), $result);

    //================================ logging ===============================

        if ($key === false)
            return "WE_HAVE_NO_PCK";

        if ($result === false || !isset($result['body']))
            return "HAVE_NO_RESPONSE";
        else
            return trim($result["body"]);
    }

    /**
     * returns a previously saved payment_cluster_key
     * or proceeds a query to get a new one
     *
     */
    function getPaymentClusterKey($orderId)
    {
        global $application;

        $pck = $this->getPCK($orderId);
        if ($pck !== false)
            return $pck;

        loadCoreFile('aal.class.php');

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));
        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

        $fname = $billingInfo->getByMask('Firstname');
        $lname = $billingInfo->getByMask('Lastname');
        $initials = $fname[0].$lname[0];
        $refnum = $orderId;

        $bcountry = $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCodeByCountryName", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

          // currency taken as customer's choice
//        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
//        $currency_code = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        // currency forced to EUR
        $currency_code = 'EUR';
        $currency_id   = modApiFunc("Localization", "getCurrencyIdByCode", $currency_code);

        $msgObj = $application->getInstance("MessageResources", "payment-module-webpay-messages", "AdminZone");
        $settings = $this->getSettings();

        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id));
        $total = number_format($total, 2, '.', '');

        $fields = array(
                 "command"            => "new_payment_cluster"
                ,"profile"            => "standard"
                ,"merchant_name"      => $settings["MODULE_MERCHANT_NAME"]
                ,"merchant_password"  => $settings["MODULE_MERCHANT_PASSWORD"]
                ,"merchant_transaction_id" => $refnum
                ,"client_id"          => $billingInfo->getByMask('Email')
                ,"price"              => $total
                ,"cur_price"          => $currency_code
                ,"client_initials"    => $initials
                ,"client_firstname"   => $billingInfo->getByMask('Firstname')
                ,"client_lastname"    => $billingInfo->getByMask('Lastname')
                ,"client_address"     => $billingInfo->getByMask('Streetline1') . ' ' . $billingInfo->getByMask('Streetline2')
                ,"client_city"        => $billingInfo->getByMask('City')
                ,"client_zip"         => $billingInfo->getByMask('Postcode')
                ,"client_country"     => $bcountry
                ,"client_email"       => $billingInfo->getByMask('Email')
                ,"client_language"    => $settings["MODULE_CLIENT_LANGUAGE"]
                ,"days_pay_period"    => 7
           );

    //================================ logging ===============================

        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_PAYMENT_CLUSTER"), $fields);

    //================================ logging ===============================

        $content = "";
        foreach ($fields as $key => $value) {
            $content .= $key . '=' . urlencode($value) . '&';
        }

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_URL"]);
        $bnc->setPOSTstring($content);
        $result = $bnc->RunRequest();

    //================================ logging ===============================

        $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_PAYMENT_CLUSTER_RESULT"), $result);

    //================================ logging ===============================

        $response = false;
        $valid = false;
        if (isset($result['body']) && $result['body'] !== false)
        {
            $response = $this->parseResponse($result['body']);
            $valid = true;

            if ($response['error'] != '')
            {
                $msg = '';
                foreach ($response['error'] as $error) {
                    $msg .= $msgObj->getMessage("MODULE_ERROR_".$error);
                }
                $this->setErrorMsg($msg);
                $valid = false;
            }
            else if ($response["id"] == '' || $response["key"] == '')
            {
                $this->setErrorMsg($msgObj->getMessage("ERROR_NO_RESPONSE"));
                $valid = false;
            }
        }
        else
        {
            $this->setErrorMsg($msgObj->getMessage("ERROR_NO_RESPONSE"));
        }

        if (!$valid)
        {
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");

            $request = new Request();
            $request->setView  ('CheckoutView');
            $request->setAction("SetCurrStep");
            $request->setKey   ('step_id', $step_id_to_redirect_to);
            $application->processActionStarted = false;
            $application->redirect($request);
            return;
        }

        $payment_cluster_id = $response["id"]["VALUE"];
        $payment_cluster_key = $response["key"]["VALUE"];

        $incomingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msgObj->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_DESCRIPTION') .
            $msgObj->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MESSAGE_INCOMING') . "\n" .
            $msgObj->getMessage('MODULE_PAYMENT_WEBPAY_LOG_CLUSTER') . "\n" .
            print_r($response, true);
        modApiFunc("Checkout", "addOrderHistory", $orderId, $incomingHistoryMessage);

        $this->setPCK($payment_cluster_key, $orderId);

        return $payment_cluster_key;
    }

/*
    // testing
    function getPaymentMode()
    {
            return "direct";
    }

    function backgroundProcess()
    {
        $this->getConfirmationData(37);
    }
//=========================================*/

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

    //==========================================================
    //====================== new payment cluster ===============

        $payment_cluster_key = $this->getPaymentClusterKey($orderId);
        $settings = $this->getSettings();

        $confirmationData = array
            (
                 "FormAction" => $settings["MODULE_URL"]."?command=show_payment_cluster&"
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                     "command"             => "show_payment_cluster"
                    ,"merchant_name"       => $settings["MODULE_MERCHANT_NAME"]
                    ,"client_language"     => $settings["MODULE_CLIENT_LANGUAGE"]
                    ,"payment_cluster_key" => $payment_cluster_key
                    ,"return_url_success"  => $self_link
                    ,"return_url_error"    => $self_link
                )
            );

    //================================ logging ===============================

        $msgObj = $application->getInstance("MessageResources", "payment-module-webpay-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_SHOW_CLUSTER"), $confirmationData);

    //================================ logging ===============================

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, that came from the payment gateway.
     *
     */
    function processData($data, $order_id)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");
        $settings = $this->getSettings();

        //
        // add incoming order message to history
        //
        $status = $this->getStatusPaymentCluster($order_id);
        $this->clearPCK();

        $incomingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MESSAGE_INCOMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_STATUS') . print_r($status, true) . "\n" .
            $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_STATUS_MEANING') . "\n" .
            $msg->getMessage('MODULE_TRANSACTION_STATUS_'.$status);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incomingHistoryMessage);

        // the status update
        switch ($status[0])
        {
            case "Y":
                // the customer card has been approved
                $EventType = "ConfirmationSuccess";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                    $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_DESCRIPTION') .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MESSAGE_APPROVED'));
                break;

            case "N":
                // the payment request is declined
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                    $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_DESCRIPTION') .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MESSAGE_DECLINED'));
                break;

            case "W":
            case "H":
            default:
                // payment error
                $EventType = "ConfirmationFailure";
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                    $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_EVENT_DESCRIPTION') .
                    $msg->getMessage('MODULE_PAYMENT_WEBPAY_LOG_MESSAGE_ERROR'));
                break;
         }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Webpay_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Webpay_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_webpay_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_webpay_setting_id'
               ,'key'               => $settings.'.pm_webpay_setting_key'
               ,'value'             => $settings.'.pm_webpay_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    /**
     * Credit card info. It will be used later.
     */
    var $ccInfoCardNumber;
    var $ccInfoCardExpMonth;
    var $ccInfoCardExpYear;
    var $ccInfoCardIDNumber;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>