<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

loadModuleFile('taxes/const.php');
loadModuleFile('location/location_api.php');

class SELECT_SM_FLAT_SR_RATES extends DB_Select
{
    function initQuery($params)
    {
        $EBS = 0.0001;
        $STATE_ID_ALL = constant("STATE_ID_ALL");
//        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $tables = $params['tables'];
        $table_rates = $params['table_rates'];
        $tr = $tables[$table_rates]['columns'];

        $this->addSelectField($tr["cost"], "cost");
        $this->WhereValue($tr["c_id"], DB_EQ, $params['countryId']);
        $this->WhereAND();
        if($params['stateId'] === NULL)
        {
            $this->WhereValue($tr["s_id"], DB_EQ, $STATE_ID_ALL);
        }
        else
        {
            $this->WhereValue($tr["s_id"], DB_EQ, $params['stateId']);
        }
        $this->WhereAND();
        $this->Where($tr["rv_from"], DB_LTE, $params['orderRateUnit'] + $EBS);
        $this->WhereAND();
        $this->Where($tr["rv_to"], DB_GTE, $params['orderRateUnit']);
        $this->WhereAND();
        $this->WhereValue($tr["ru_id"], DB_EQ, $params['MODULE_RATE_UNIT_ID']);
    }
}

class SELECT_SM_FLAT_SR_RATES_ALL_STATES extends DB_Select
{
    function initQuery($params)
    {
        $EBS = 0.0001;
//        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $tables = $params['tables'];
        $table_rates = $params['table_rates'];
        $tr = $tables[$table_rates]['columns'];

        $this->addSelectField($tr["cost"], "cost");
        $this->WhereValue($tr["c_id"], DB_EQ, $params['countryId']);
        $this->WhereAND();
        $this->WhereValue($tr["s_id"], DB_EQ, Location::get_constant("ALL_OTHER_STATES_STATE_ID"));
        $this->WhereAND();
        $this->Where($tr["rv_from"], DB_LTE, $params['orderRateUnit'] + $EBS);
        $this->WhereAND();
        $this->Where($tr["rv_to"], DB_GTE, $params['orderRateUnit']);
        $this->WhereAND();
        $this->WhereValue($tr["ru_id"], DB_EQ, $params['MODULE_RATE_UNIT_ID']);
    }
}

class SELECT_SM_FLAT_SR_RATES_ALL_COUNTRIES extends DB_Select
{
    function initQuery($params)
    {
        $EBS = 0.0001;
//        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $tables = $params['tables'];
        $table_rates = $params['table_rates'];
        $tr = $tables[$table_rates]['columns'];

        $this->addSelectField($tr["cost"], "cost");
        $this->WhereValue($tr["c_id"], DB_EQ, Location::get_constant("ALL_OTHER_COUNTRIES_COUNTRY_ID"));
        /* Query shortened for speed optimization, though result must be the same:
           if country_id = ALL_COUNTRIES, then corresponding
              state_id MUST be STATE_UNDEFINED_STATE_ID
        */
        //$this->WhereAND();
        //$this->WhereValue($tr["s_id"], DB_EQ, Location::get_constant("STATE_UNDEFINED_STATE_ID"));
        $this->WhereAND();
        $this->Where($tr["rv_from"], DB_LTE, $params['orderRateUnit'] + $EBS);
        $this->WhereAND();
        $this->Where($tr["rv_to"], DB_GTE, $params['orderRateUnit']);
        $this->WhereAND();
        $this->WhereValue($tr["ru_id"], DB_EQ, $params['MODULE_RATE_UNIT_ID']);
    }
}

class SELECT_SM_FLAT_SR_RATES_ALL_RATES extends DB_Select
{
    function initQuery($params)
    {
//        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $tables = $params['tables'];
        $table_rates = $params['table_rates'];
        $tr = $tables[$table_rates]['columns'];

        $this->addSelectField($tr["id"], "id");
        $this->addSelectField($tr["c_id"], "c_id");
        $this->addSelectField($tr["s_id"], "s_id");
        $this->addSelectField($tr["rv_from"], "rv_from");
        $this->addSelectField($tr["rv_to"], "rv_to");
        $this->addSelectField($tr["ru_id"], "ru_id");
        $this->addSelectField($tr["cost_type_id"], "cost_type_id");
        $this->addSelectField($tr["cost"], "cost");

        $this->WhereValue('', '', '1');
        if($params['ru_id'] !== NULL)
        {
            $this->WhereAnd();
            $this->WhereValue($tr["ru_id"], DB_EQ, $params['ru_id']);
        }
        if($params['cost_type_id'] !== NULL)
        {
            $this->WhereAnd();
            $this->WhereValue($tr["cost_type_id"], DB_EQ, $params['cost_type_id']);
        }
        $this->SelectOrder($tr['c_id']);
        $this->SelectOrder($tr['s_id']);
        $this->SelectOrder($tr['rv_from']);
    }
}

class SELECT_SM_FLAT_SR_RATE_UNITS extends DB_Select
{
    function initQuery($params)
    {
//        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $tables = $params['tables'];
        $table_rates = $params['table_units'];
        $ru = $tables[$table_rates]['columns'];

        $this->addSelectField($ru["id"], "id");
        $this->addSelectField($ru["name"], "name");
        $this->addSelectField($ru["type"], "type");
        $this->addSelectField($ru["descr"], "descr");
    }
}
?>