<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Shipping Module "Flat Shipping Rates2".
 *
 * @package ShippingModuleFlatShippingRates2
 * @author Garafutdinov Ravil
 */
loadClass('Shipping_Module_Flat_Shipping_Rates');
class Shipping_Module_Flat_Shipping_Rates2 extends Shipping_Module_Flat_Shipping_Rates
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    function getUID()
    {
        return "9F816342-A716-4427-B471-76CE4D27EF69";
    }

    /**
     *
     */
    /**
     * Returns module info.
     */
    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniqueShippingModuleID" => $this->getUID(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "flat_shipping_rates2_input_az",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates2::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $tables = Shipping_Module_Flat_Shipping_Rates2::getTables();
        $tableNames = Shipping_Module_Flat_Shipping_Rates2::getTableNames();
        $query = new DB_Table_Create($tables);

        $table = $tableNames['table_units'];            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        for ($i=1; $i<=3; $i++)
        {
            $query = new DB_Insert($table);
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue('SM_TBL_RTS_RU_00'.$i, $columns['name']);
            $query->addInsertValue('SM_TBL_RTS_RU_TYPE_00'.$i, $columns['type']);
            $query->addInsertValue('SM_TBL_RTS_RU_DESCR_00'.$i, $columns['descr']);
            $application->db->getDB_Result($query);
        }

        $table = $tableNames['table_settings'];            #  the name of the filled table
        $columns = $tables[$table]['columns'];  #  the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME_2')).':"'.$obj->getMessage('MODULE_NAME_2').'";', $columns['value']);
        $application->db->getDB_Result($query);
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_RATE_UNIT_ID", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       ShippingModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Shipping_Module_Flat_Shipping_Rates2',
               'OnRemovePersonInfoType');
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates2::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Shipping_Module_Flat_Shipping_Rates2::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();
        $tableNames = Shipping_Module_Flat_Shipping_Rates2::getTableNames();

        $rate_units = $tableNames['table_units'];
        $tables[$rate_units] = array();
        $tables[$rate_units]['columns'] = array
            (
                'id'                => $rate_units.'.sm_flat_shipping_rates_rate_unit_id'
               ,'name'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_name'
               ,'type'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_type'
               ,'descr'             => $rate_units.'.sm_flat_shipping_rates_rate_unit_descr'
            );
        $tables[$rate_units]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR255
               ,'type'              => DBQUERY_FIELD_TYPE_CHAR255
               ,'descr'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$rate_units]['primary'] = array
            (
                'id'
            );

        $table_rates = $tableNames['table_rates'];
        $tables[$table_rates] = array();
        $tables[$table_rates]['columns'] = array
            (
                'id'                => $table_rates.'.sm_flat_shipping_rates_table_rate_id'
               ,'c_id'              => $table_rates.'.sm_flat_shipping_rates_country_id'
               ,'s_id'              => $table_rates.'.sm_flat_shipping_rates_state_id'
               ,'rv_from'           => $table_rates.'.sm_flat_shipping_rates_rate_value_from'
               ,'rv_to'             => $table_rates.'.sm_flat_shipping_rates_rate_value_to'
               ,'ru_id'             => $table_rates.'.sm_flat_shipping_rates_rate_unit_id'
               ,'cost_type_id'      => $table_rates.'.sm_flat_shipping_rates_rate_cost_type_id'
               ,'cost'              => $table_rates.'.sm_flat_shipping_rates_rate_cost'
            );
        $tables[$table_rates]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'c_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'s_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'rv_from'           => DBQUERY_FIELD_TYPE_FLOAT
               ,'rv_to'             => DBQUERY_FIELD_TYPE_FLOAT
               ,'ru_id'             => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'cost_type_id'      => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'cost'              => DBQUERY_FIELD_TYPE_FLOAT
            );
        $tables[$table_rates]['primary'] = array
            (
                'id'
            );
        $tables[$table_rates]['indexes'] = array
            (
                'IDX_c' => 'c_id'
               ,'IDX_s' => 's_id'
               ,'IDX_rv_from' => 'rv_from'
               ,'IDX_rv_to' => 'rv_to'
            );

        $settings = $tableNames['table_settings'];
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.sm_flat_shipping_rates_setting_id'
               ,'key'               => $settings.'.sm_flat_shipping_rates_setting_key'
               ,'value'             => $settings.'.sm_flat_shipping_rates_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function getTableNames()
    {
        return array(
             'table_settings' => 'sm_flat_shipping_rates2_settings'
            ,'table_rates'    => 'sm_flat_shipping_rates2_rates_table'
            ,'table_units'    => 'sm_flat_shipping_rates2_rate_units'
        );
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $tableNames = Shipping_Module_Flat_Shipping_Rates2::getTableNames();
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => $tableNames['table_settings']));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    var $table_units    = 'sm_flat_shipping_rates2_rate_units';
    var $table_settings = 'sm_flat_shipping_rates2_settings';
    var $table_rates    = 'sm_flat_shipping_rates2_rates_table';

    /**#@-*/
}
?>